/* sudoku-board.c generated by valac 0.26.0.30-a52f5a, the Vala compiler
 * generated from sudoku-board.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define TYPE_SUDOKU_BOARD (sudoku_board_get_type ())
#define SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_BOARD, SudokuBoard))
#define SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_BOARD, SudokuBoardClass))
#define IS_SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_BOARD))
#define IS_SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_BOARD))
#define SUDOKU_BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_BOARD, SudokuBoardClass))

typedef struct _SudokuBoard SudokuBoard;
typedef struct _SudokuBoardClass SudokuBoardClass;
typedef struct _SudokuBoardPrivate SudokuBoardPrivate;

#define TYPE_COORD (coord_get_type ())
typedef struct _Coord Coord;

#define TYPE_DIFFICULTY_CATEGORY (difficulty_category_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _coord_free0(var) ((var == NULL) ? NULL : (var = (coord_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_HOUSE (house_get_type ())

#define TYPE_CELL (cell_get_type ())
typedef struct _Cell Cell;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Coord {
	gint row;
	gint col;
};

struct _SudokuBoard {
	GObject parent_instance;
	SudokuBoardPrivate * priv;
	gint* cells;
	gint cells_length1;
	gint cells_length2;
	gboolean* is_fixed;
	gint is_fixed_length1;
	gint is_fixed_length2;
	GeeSet* broken_coords;
	GeeList* coords_for_col;
	GeeList* coords_for_row;
	GeeMap* coords_for_block;
};

struct _SudokuBoardClass {
	GObjectClass parent_class;
};

typedef enum  {
	DIFFICULTY_CATEGORY_UNKNOWN,
	DIFFICULTY_CATEGORY_EASY,
	DIFFICULTY_CATEGORY_MEDIUM,
	DIFFICULTY_CATEGORY_HARD,
	DIFFICULTY_CATEGORY_VERY_HARD
} DifficultyCategory;

struct _SudokuBoardPrivate {
	gboolean* possible_in_row;
	gint possible_in_row_length1;
	gint possible_in_row_length2;
	gboolean* possible_in_col;
	gint possible_in_col_length1;
	gint possible_in_col_length2;
	gboolean* possible_in_block;
	gint possible_in_block_length1;
	gint possible_in_block_length2;
	gint possible_in_block_length3;
	gboolean* earmarks;
	gint earmarks_length1;
	gint earmarks_length2;
	gint earmarks_length3;
	gint n_earmarks;
	gdouble _previous_played_time;
	DifficultyCategory _difficulty_category;
	gint _block_rows;
	gint _block_cols;
	gint _rows;
	gint _cols;
	gint _filled;
	gint _fixed;
};

typedef enum  {
	HOUSE_ROW,
	HOUSE_COLUMN,
	HOUSE_BLOCK
} House;

struct _Cell {
	Coord coord;
	gint val;
};


static gpointer sudoku_board_parent_class = NULL;

GType sudoku_board_get_type (void) G_GNUC_CONST;
GType coord_get_type (void) G_GNUC_CONST;
Coord* coord_dup (const Coord* self);
void coord_free (Coord* self);
GType difficulty_category_get_type (void) G_GNUC_CONST;
#define SUDOKU_BOARD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SUDOKU_BOARD, SudokuBoardPrivate))
enum  {
	SUDOKU_BOARD_DUMMY_PROPERTY,
	SUDOKU_BOARD_PREVIOUS_PLAYED_TIME,
	SUDOKU_BOARD_DIFFICULTY_CATEGORY,
	SUDOKU_BOARD_BLOCK_ROWS,
	SUDOKU_BOARD_BLOCK_COLS,
	SUDOKU_BOARD_ROWS,
	SUDOKU_BOARD_COLS,
	SUDOKU_BOARD_MAX_VAL,
	SUDOKU_BOARD_BROKEN,
	SUDOKU_BOARD_FILLED,
	SUDOKU_BOARD_FIXED,
	SUDOKU_BOARD_COMPLETE
};
gboolean sudoku_board_is_empty (SudokuBoard* self);
gint sudoku_board_get_filled (SudokuBoard* self);
gint sudoku_board_get_fixed (SudokuBoard* self);
SudokuBoard* sudoku_board_new (gint block_rows, gint block_cols);
SudokuBoard* sudoku_board_construct (GType object_type, gint block_rows, gint block_cols);
static void sudoku_board_set_cols (SudokuBoard* self, gint value);
static void sudoku_board_set_rows (SudokuBoard* self, gint value);
static void sudoku_board_set_block_rows (SudokuBoard* self, gint value);
static void sudoku_board_set_block_cols (SudokuBoard* self, gint value);
gint sudoku_board_get_rows (SudokuBoard* self);
gint sudoku_board_get_cols (SudokuBoard* self);
gint sudoku_board_get_max_val (SudokuBoard* self);
gint coord_hash (Coord* coord);
gboolean coord_equal (Coord* a, Coord* b);
void coord_init (Coord *self, gint row, gint col);
SudokuBoard* sudoku_board_clone (SudokuBoard* self);
gint sudoku_board_get_block_rows (SudokuBoard* self);
gint sudoku_board_get_block_cols (SudokuBoard* self);
static gint* _vala_array_dup1 (gint* self, int length);
static gboolean* _vala_array_dup2 (gboolean* self, int length);
static gboolean* _vala_array_dup3 (gboolean* self, int length);
static gboolean* _vala_array_dup4 (gboolean* self, int length);
static gboolean* _vala_array_dup5 (gboolean* self, int length);
static void sudoku_board_set_filled (SudokuBoard* self, gint value);
static void sudoku_board_set_fixed (SudokuBoard* self, gint value);
static gboolean* _vala_array_dup6 (gboolean* self, int length);
DifficultyCategory sudoku_board_get_difficulty_category (SudokuBoard* self);
void sudoku_board_set_difficulty_category (SudokuBoard* self, DifficultyCategory value);
void sudoku_board_enable_earmark (SudokuBoard* self, gint row, gint column, gint digit);
void sudoku_board_disable_earmark (SudokuBoard* self, gint row, gint column, gint digit);
gboolean sudoku_board_is_earmark_enabled (SudokuBoard* self, gint row, gint column, gint digit);
gboolean sudoku_board_is_possible (SudokuBoard* self, gint row, gint col, gint val);
gint sudoku_board_count_possibilities (SudokuBoard* self, gint row, gint col);
gint* sudoku_board_get_possibilities (SudokuBoard* self, gint row, gint col, int* result_length1);
static gint* _vala_array_dup7 (gint* self, int length);
gboolean* sudoku_board_get_possibilities_as_bool_array (SudokuBoard* self, gint row, gint col, int* result_length1);
void sudoku_board_get_block_for (SudokuBoard* self, gint row, gint col, Coord* result);
void sudoku_board_insert (SudokuBoard* self, gint row, gint col, gint val, gboolean is_fixed);
void sudoku_board_remove (SudokuBoard* self, gint row, gint col, gboolean is_fixed);
static void sudoku_board_mark_breakages_for (SudokuBoard* self, GeeList* coords, gint val);
gboolean sudoku_board_get_complete (SudokuBoard* self);
void sudoku_board_set (SudokuBoard* self, gint row, gint col, gint val);
gint sudoku_board_get (SudokuBoard* self, gint row, gint col);
static void sudoku_board_remove_breakages_for (SudokuBoard* self, GeeList* coords, gint val);
GeeSet* sudoku_board_get_occurances (SudokuBoard* self, GeeList* coords, gint val);
gboolean sudoku_board_row_contains (SudokuBoard* self, gint row, gint val);
gboolean sudoku_board_col_contains (SudokuBoard* self, gint col, gint val);
gboolean sudoku_board_block_contains (SudokuBoard* self, Coord* block, gint val);
void sudoku_board_to_initial_state (SudokuBoard* self);
void sudoku_board_print (SudokuBoard* self, gint indent);
void sudoku_board_get_string (SudokuBoard* self);
gchar* sudoku_board_to_string (SudokuBoard* self, gboolean get_original_state);
gint* sudoku_board_get_cells (SudokuBoard* self, int* result_length1, int* result_length2);
static gint* _vala_array_dup8 (gint* self, int length);
GeeHashMap* sudoku_board_calculate_open_squares (SudokuBoard* self);
gboolean sudoku_board_is_finished (SudokuBoard* self);
const gchar* sudoku_saver_get_finishgame_dir (void);
gchar* sudoku_board_get_earmarks_string (SudokuBoard* self, gint row, gint col);
gdouble sudoku_board_get_previous_played_time (SudokuBoard* self);
void sudoku_board_set_previous_played_time (SudokuBoard* self, gdouble value);
gboolean sudoku_board_get_broken (SudokuBoard* self);
static void sudoku_board_finalize (GObject* obj);
static void _vala_sudoku_board_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_sudoku_board_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType house_get_type (void) G_GNUC_CONST;
GType cell_get_type (void) G_GNUC_CONST;
Cell* cell_dup (const Cell* self);
void cell_free (Cell* self);
void cell_init (Cell *self, Coord* coord, gint val);
gint cell_hash (Cell* cell);
gboolean cell_equal (Cell* a, Cell* b);
gchar* difficulty_category_to_string (DifficultyCategory self);
gchar* difficulty_category_to_untranslated_string (DifficultyCategory self);
DifficultyCategory difficulty_category_from_string (const gchar* input);


gboolean sudoku_board_is_empty (SudokuBoard* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 75 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = self->priv->_filled;
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = self->priv->_fixed;
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp1_ == _tmp2_) {
#line 244 "sudoku-board.c"
		gint _tmp3_ = 0;
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp3_ = self->priv->n_earmarks;
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp0_ = _tmp3_ == 0;
#line 250 "sudoku-board.c"
	} else {
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 254 "sudoku-board.c"
	}
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 77 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 260 "sudoku-board.c"
}


SudokuBoard* sudoku_board_construct (GType object_type, gint block_rows, gint block_cols) {
	SudokuBoard * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gboolean* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gboolean* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gboolean* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	gboolean* _tmp20_ = NULL;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	gboolean* _tmp25_ = NULL;
	GeeHashSet* _tmp68_ = NULL;
	GeeArrayList* _tmp69_ = NULL;
	GeeList* _tmp97_ = NULL;
	GeeList* _tmp98_ = NULL;
	GeeList* _tmp99_ = NULL;
	GeeArrayList* _tmp100_ = NULL;
	GeeList* _tmp128_ = NULL;
	GeeList* _tmp129_ = NULL;
	GeeList* _tmp130_ = NULL;
	GeeHashMap* _tmp131_ = NULL;
	GeeMap* _tmp186_ = NULL;
	GeeMap* _tmp187_ = NULL;
	GeeMap* _tmp188_ = NULL;
#line 94 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self = (SudokuBoard*) g_object_new (object_type, NULL);
#line 96 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = block_rows;
#line 96 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = block_cols;
#line 96 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	sudoku_board_set_cols (self, _tmp0_ * _tmp1_);
#line 96 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	sudoku_board_set_rows (self, _tmp0_ * _tmp1_);
#line 97 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = block_rows;
#line 97 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	sudoku_board_set_block_rows (self, _tmp2_);
#line 98 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = block_cols;
#line 98 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	sudoku_board_set_block_cols (self, _tmp3_);
#line 99 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = self->priv->_rows;
#line 99 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5_ = self->priv->_cols;
#line 99 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp6_ = g_new0 (gint, _tmp4_ * _tmp5_);
#line 99 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->cells = (g_free (self->cells), NULL);
#line 99 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->cells = _tmp6_;
#line 99 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->cells_length1 = _tmp4_;
#line 99 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->cells_length2 = _tmp5_;
#line 100 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp7_ = self->priv->_rows;
#line 100 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp8_ = self->priv->_cols;
#line 100 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9_ = g_new0 (gboolean, _tmp7_ * _tmp8_);
#line 100 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->is_fixed = (g_free (self->is_fixed), NULL);
#line 100 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->is_fixed = _tmp9_;
#line 100 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->is_fixed_length1 = _tmp7_;
#line 100 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->is_fixed_length2 = _tmp8_;
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp10_ = self->priv->_rows;
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp11_ = self->priv->_cols;
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp12_ = g_new0 (gboolean, _tmp10_ * _tmp11_);
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_row = (g_free (self->priv->possible_in_row), NULL);
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_row = _tmp12_;
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_row_length1 = _tmp10_;
#line 101 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_row_length2 = _tmp11_;
#line 102 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp13_ = self->priv->_cols;
#line 102 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp14_ = self->priv->_rows;
#line 102 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp15_ = g_new0 (gboolean, _tmp13_ * _tmp14_);
#line 102 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_col = (g_free (self->priv->possible_in_col), NULL);
#line 102 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_col = _tmp15_;
#line 102 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_col_length1 = _tmp13_;
#line 102 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_col_length2 = _tmp14_;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp16_ = block_rows;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp17_ = block_cols;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp18_ = block_rows;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp19_ = block_cols;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp20_ = g_new0 (gboolean, (_tmp16_ * _tmp17_) * (_tmp18_ * _tmp19_));
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_block = (g_free (self->priv->possible_in_block), NULL);
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_block = _tmp20_;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_block_length1 = _tmp16_;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_block_length2 = _tmp17_;
#line 103 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_block_length3 = _tmp18_ * _tmp19_;
#line 104 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp21_ = self->priv->_rows;
#line 104 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp22_ = self->priv->_cols;
#line 104 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp23_ = sudoku_board_get_max_val (self);
#line 104 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp24_ = _tmp23_;
#line 104 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp25_ = g_new0 (gboolean, (_tmp21_ * _tmp22_) * _tmp24_);
#line 104 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->earmarks = (g_free (self->priv->earmarks), NULL);
#line 104 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->earmarks = _tmp25_;
#line 104 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->earmarks_length1 = _tmp21_;
#line 104 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->earmarks_length2 = _tmp22_;
#line 104 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->earmarks_length3 = _tmp24_;
#line 419 "sudoku-board.c"
	{
		gint l1 = 0;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		l1 = 0;
#line 424 "sudoku-board.c"
		{
			gboolean _tmp26_ = FALSE;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp26_ = TRUE;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 431 "sudoku-board.c"
				gint _tmp28_ = 0;
				gint _tmp29_ = 0;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp26_) {
#line 436 "sudoku-board.c"
					gint _tmp27_ = 0;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp27_ = l1;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l1 = _tmp27_ + 1;
#line 442 "sudoku-board.c"
				}
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp26_ = FALSE;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp28_ = l1;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp29_ = self->priv->_rows;
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp28_ < _tmp29_)) {
#line 106 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 454 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l2 = 0;
#line 460 "sudoku-board.c"
					{
						gboolean _tmp30_ = FALSE;
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp30_ = TRUE;
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 467 "sudoku-board.c"
							gint _tmp32_ = 0;
							gint _tmp33_ = 0;
							gint* _tmp34_ = NULL;
							gint _tmp34__length1 = 0;
							gint _tmp34__length2 = 0;
							gint _tmp35_ = 0;
							gint _tmp36_ = 0;
							gint _tmp37_ = 0;
							gboolean* _tmp38_ = NULL;
							gint _tmp38__length1 = 0;
							gint _tmp38__length2 = 0;
							gint _tmp39_ = 0;
							gint _tmp40_ = 0;
							gboolean _tmp41_ = FALSE;
							gboolean* _tmp42_ = NULL;
							gint _tmp42__length1 = 0;
							gint _tmp42__length2 = 0;
							gint _tmp43_ = 0;
							gint _tmp44_ = 0;
							gboolean _tmp45_ = FALSE;
							gboolean* _tmp46_ = NULL;
							gint _tmp46__length1 = 0;
							gint _tmp46__length2 = 0;
							gint _tmp47_ = 0;
							gint _tmp48_ = 0;
							gboolean _tmp49_ = FALSE;
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp30_) {
#line 496 "sudoku-board.c"
								gint _tmp31_ = 0;
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp31_ = l2;
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								l2 = _tmp31_ + 1;
#line 502 "sudoku-board.c"
							}
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp30_ = FALSE;
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp32_ = l2;
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp33_ = self->priv->_cols;
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp32_ < _tmp33_)) {
#line 108 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 514 "sudoku-board.c"
							}
#line 110 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp34_ = self->cells;
#line 110 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp34__length1 = self->cells_length1;
#line 110 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp34__length2 = self->cells_length2;
#line 110 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp35_ = l1;
#line 110 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp36_ = l2;
#line 110 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp34_[(_tmp35_ * _tmp34__length2) + _tmp36_] = 0;
#line 110 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp37_ = _tmp34_[(_tmp35_ * _tmp34__length2) + _tmp36_];
#line 111 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp38_ = self->is_fixed;
#line 111 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp38__length1 = self->is_fixed_length1;
#line 111 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp38__length2 = self->is_fixed_length2;
#line 111 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp39_ = l1;
#line 111 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp40_ = l2;
#line 111 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp38_[(_tmp39_ * _tmp38__length2) + _tmp40_] = FALSE;
#line 111 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp41_ = _tmp38_[(_tmp39_ * _tmp38__length2) + _tmp40_];
#line 112 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp42_ = self->priv->possible_in_row;
#line 112 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp42__length1 = self->priv->possible_in_row_length1;
#line 112 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp42__length2 = self->priv->possible_in_row_length2;
#line 112 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp43_ = l1;
#line 112 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp44_ = l2;
#line 112 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp42_[(_tmp43_ * _tmp42__length2) + _tmp44_] = TRUE;
#line 112 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp45_ = _tmp42_[(_tmp43_ * _tmp42__length2) + _tmp44_];
#line 113 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp46_ = self->priv->possible_in_col;
#line 113 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp46__length1 = self->priv->possible_in_col_length1;
#line 113 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp46__length2 = self->priv->possible_in_col_length2;
#line 113 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp47_ = l2;
#line 113 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp48_ = l1;
#line 113 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp46_[(_tmp47_ * _tmp46__length2) + _tmp48_] = TRUE;
#line 113 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp49_ = _tmp46_[(_tmp47_ * _tmp46__length2) + _tmp48_];
#line 572 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint l1 = 0;
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		l1 = 0;
#line 583 "sudoku-board.c"
		{
			gboolean _tmp50_ = FALSE;
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp50_ = TRUE;
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 590 "sudoku-board.c"
				gint _tmp52_ = 0;
				gint _tmp53_ = 0;
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp50_) {
#line 595 "sudoku-board.c"
					gint _tmp51_ = 0;
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp51_ = l1;
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l1 = _tmp51_ + 1;
#line 601 "sudoku-board.c"
				}
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp50_ = FALSE;
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp52_ = l1;
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp53_ = block_rows;
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp52_ < _tmp53_)) {
#line 116 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 613 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l2 = 0;
#line 619 "sudoku-board.c"
					{
						gboolean _tmp54_ = FALSE;
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp54_ = TRUE;
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 626 "sudoku-board.c"
							gint _tmp56_ = 0;
							gint _tmp57_ = 0;
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp54_) {
#line 631 "sudoku-board.c"
								gint _tmp55_ = 0;
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp55_ = l2;
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								l2 = _tmp55_ + 1;
#line 637 "sudoku-board.c"
							}
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp54_ = FALSE;
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp56_ = l2;
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp57_ = block_cols;
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp56_ < _tmp57_)) {
#line 118 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 649 "sudoku-board.c"
							}
							{
								gint l3 = 0;
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								l3 = 0;
#line 655 "sudoku-board.c"
								{
									gboolean _tmp58_ = FALSE;
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp58_ = TRUE;
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									while (TRUE) {
#line 662 "sudoku-board.c"
										gint _tmp60_ = 0;
										gint _tmp61_ = 0;
										gint _tmp62_ = 0;
										gboolean* _tmp63_ = NULL;
										gint _tmp63__length1 = 0;
										gint _tmp63__length2 = 0;
										gint _tmp63__length3 = 0;
										gint _tmp64_ = 0;
										gint _tmp65_ = 0;
										gint _tmp66_ = 0;
										gboolean _tmp67_ = FALSE;
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										if (!_tmp58_) {
#line 676 "sudoku-board.c"
											gint _tmp59_ = 0;
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
											_tmp59_ = l3;
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
											l3 = _tmp59_ + 1;
#line 682 "sudoku-board.c"
										}
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp58_ = FALSE;
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp60_ = l3;
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp61_ = sudoku_board_get_max_val (self);
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp62_ = _tmp61_;
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										if (!(_tmp60_ < _tmp62_)) {
#line 120 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
											break;
#line 696 "sudoku-board.c"
										}
#line 121 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp63_ = self->priv->possible_in_block;
#line 121 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp63__length1 = self->priv->possible_in_block_length1;
#line 121 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp63__length2 = self->priv->possible_in_block_length2;
#line 121 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp63__length3 = self->priv->possible_in_block_length3;
#line 121 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp64_ = l1;
#line 121 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp65_ = l2;
#line 121 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp66_ = l3;
#line 121 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp63_[(((_tmp64_ * _tmp63__length2) + _tmp65_) * _tmp63__length3) + _tmp66_] = TRUE;
#line 121 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										_tmp67_ = _tmp63_[(((_tmp64_ * _tmp63__length2) + _tmp65_) * _tmp63__length3) + _tmp66_];
#line 716 "sudoku-board.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 125 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp68_ = gee_hash_set_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, coord_free, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 125 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->broken_coords);
#line 125 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->broken_coords = (GeeSet*) _tmp68_;
#line 127 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp69_ = gee_array_list_new (GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 127 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_col);
#line 127 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->coords_for_col = (GeeList*) _tmp69_;
#line 738 "sudoku-board.c"
	{
		gint col = 0;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		col = 0;
#line 743 "sudoku-board.c"
		{
			gboolean _tmp70_ = FALSE;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp70_ = TRUE;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 750 "sudoku-board.c"
				gint _tmp72_ = 0;
				gint _tmp73_ = 0;
				GeeList* _tmp74_ = NULL;
				GeeArrayList* _tmp75_ = NULL;
				GeeArrayList* _tmp76_ = NULL;
				GeeList* _tmp88_ = NULL;
				gint _tmp89_ = 0;
				GeeList* _tmp90_ = NULL;
				gint _tmp91_ = 0;
				gpointer _tmp92_ = NULL;
				GeeList* _tmp93_ = NULL;
				GeeList* _tmp94_ = NULL;
				GeeList* _tmp95_ = NULL;
				GeeList* _tmp96_ = NULL;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp70_) {
#line 767 "sudoku-board.c"
					gint _tmp71_ = 0;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp71_ = col;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					col = _tmp71_ + 1;
#line 773 "sudoku-board.c"
				}
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp70_ = FALSE;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp72_ = col;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp73_ = self->priv->_cols;
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp72_ < _tmp73_)) {
#line 128 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 785 "sudoku-board.c"
				}
#line 130 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp74_ = self->coords_for_col;
#line 130 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp75_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 130 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp76_ = _tmp75_;
#line 130 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp74_, (GeeList*) _tmp76_);
#line 130 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_g_object_unref0 (_tmp76_);
#line 797 "sudoku-board.c"
				{
					gint row = 0;
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					row = 0;
#line 802 "sudoku-board.c"
					{
						gboolean _tmp77_ = FALSE;
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp77_ = TRUE;
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 809 "sudoku-board.c"
							gint _tmp79_ = 0;
							gint _tmp80_ = 0;
							GeeList* _tmp81_ = NULL;
							gint _tmp82_ = 0;
							gpointer _tmp83_ = NULL;
							GeeList* _tmp84_ = NULL;
							gint _tmp85_ = 0;
							gint _tmp86_ = 0;
							Coord _tmp87_ = {0};
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp77_) {
#line 821 "sudoku-board.c"
								gint _tmp78_ = 0;
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp78_ = row;
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								row = _tmp78_ + 1;
#line 827 "sudoku-board.c"
							}
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp77_ = FALSE;
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp79_ = row;
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp80_ = self->priv->_rows;
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp79_ < _tmp80_)) {
#line 131 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 839 "sudoku-board.c"
							}
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp81_ = self->coords_for_col;
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp82_ = col;
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp83_ = gee_list_get (_tmp81_, _tmp82_);
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp84_ = (GeeList*) _tmp83_;
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp85_ = row;
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp86_ = col;
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							coord_init (&_tmp87_, _tmp85_, _tmp86_);
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp84_, &_tmp87_);
#line 133 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_g_object_unref0 (_tmp84_);
#line 859 "sudoku-board.c"
						}
					}
				}
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp88_ = self->coords_for_col;
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp89_ = col;
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp90_ = self->coords_for_col;
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp91_ = col;
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp92_ = gee_list_get (_tmp90_, _tmp91_);
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp93_ = (GeeList*) _tmp92_;
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp94_ = gee_list_get_read_only_view (_tmp93_);
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp95_ = _tmp94_;
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp96_ = _tmp95_;
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				gee_list_set (_tmp88_, _tmp89_, _tmp96_);
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_g_object_unref0 (_tmp96_);
#line 135 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_g_object_unref0 (_tmp93_);
#line 887 "sudoku-board.c"
			}
		}
	}
#line 137 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp97_ = self->coords_for_col;
#line 137 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp98_ = gee_list_get_read_only_view (_tmp97_);
#line 137 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp99_ = _tmp98_;
#line 137 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_col);
#line 137 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->coords_for_col = _tmp99_;
#line 139 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp100_ = gee_array_list_new (GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 139 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_row);
#line 139 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->coords_for_row = (GeeList*) _tmp100_;
#line 907 "sudoku-board.c"
	{
		gint row = 0;
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		row = 0;
#line 912 "sudoku-board.c"
		{
			gboolean _tmp101_ = FALSE;
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp101_ = TRUE;
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 919 "sudoku-board.c"
				gint _tmp103_ = 0;
				gint _tmp104_ = 0;
				GeeList* _tmp105_ = NULL;
				GeeArrayList* _tmp106_ = NULL;
				GeeArrayList* _tmp107_ = NULL;
				GeeList* _tmp119_ = NULL;
				gint _tmp120_ = 0;
				GeeList* _tmp121_ = NULL;
				gint _tmp122_ = 0;
				gpointer _tmp123_ = NULL;
				GeeList* _tmp124_ = NULL;
				GeeList* _tmp125_ = NULL;
				GeeList* _tmp126_ = NULL;
				GeeList* _tmp127_ = NULL;
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp101_) {
#line 936 "sudoku-board.c"
					gint _tmp102_ = 0;
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp102_ = row;
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					row = _tmp102_ + 1;
#line 942 "sudoku-board.c"
				}
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp101_ = FALSE;
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp103_ = row;
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp104_ = self->priv->_rows;
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp103_ < _tmp104_)) {
#line 140 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 954 "sudoku-board.c"
				}
#line 142 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp105_ = self->coords_for_row;
#line 142 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp106_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 142 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp107_ = _tmp106_;
#line 142 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp105_, (GeeList*) _tmp107_);
#line 142 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_g_object_unref0 (_tmp107_);
#line 966 "sudoku-board.c"
				{
					gint col = 0;
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					col = 0;
#line 971 "sudoku-board.c"
					{
						gboolean _tmp108_ = FALSE;
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp108_ = TRUE;
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 978 "sudoku-board.c"
							gint _tmp110_ = 0;
							gint _tmp111_ = 0;
							GeeList* _tmp112_ = NULL;
							gint _tmp113_ = 0;
							gpointer _tmp114_ = NULL;
							GeeList* _tmp115_ = NULL;
							gint _tmp116_ = 0;
							gint _tmp117_ = 0;
							Coord _tmp118_ = {0};
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp108_) {
#line 990 "sudoku-board.c"
								gint _tmp109_ = 0;
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp109_ = col;
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								col = _tmp109_ + 1;
#line 996 "sudoku-board.c"
							}
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp108_ = FALSE;
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp110_ = col;
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp111_ = self->priv->_cols;
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp110_ < _tmp111_)) {
#line 143 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 1008 "sudoku-board.c"
							}
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp112_ = self->coords_for_row;
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp113_ = row;
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp114_ = gee_list_get (_tmp112_, _tmp113_);
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp115_ = (GeeList*) _tmp114_;
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp116_ = row;
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp117_ = col;
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							coord_init (&_tmp118_, _tmp116_, _tmp117_);
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp115_, &_tmp118_);
#line 145 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_g_object_unref0 (_tmp115_);
#line 1028 "sudoku-board.c"
						}
					}
				}
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp119_ = self->coords_for_row;
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp120_ = row;
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp121_ = self->coords_for_row;
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp122_ = row;
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp123_ = gee_list_get (_tmp121_, _tmp122_);
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp124_ = (GeeList*) _tmp123_;
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp125_ = gee_list_get_read_only_view (_tmp124_);
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp126_ = _tmp125_;
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp127_ = _tmp126_;
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				gee_list_set (_tmp119_, _tmp120_, _tmp127_);
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_g_object_unref0 (_tmp127_);
#line 147 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_g_object_unref0 (_tmp124_);
#line 1056 "sudoku-board.c"
			}
		}
	}
#line 149 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp128_ = self->coords_for_row;
#line 149 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp129_ = gee_list_get_read_only_view (_tmp128_);
#line 149 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp130_ = _tmp129_;
#line 149 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_row);
#line 149 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->coords_for_row = _tmp130_;
#line 151 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp131_ = gee_hash_map_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, coord_free, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL, NULL, NULL, NULL);
#line 151 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_block);
#line 151 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->coords_for_block = (GeeMap*) _tmp131_;
#line 1076 "sudoku-board.c"
	{
		gint col = 0;
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		col = 0;
#line 1081 "sudoku-board.c"
		{
			gboolean _tmp132_ = FALSE;
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp132_ = TRUE;
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 1088 "sudoku-board.c"
				gint _tmp134_ = 0;
				gint _tmp135_ = 0;
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp132_) {
#line 1093 "sudoku-board.c"
					gint _tmp133_ = 0;
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp133_ = col;
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					col = _tmp133_ + 1;
#line 1099 "sudoku-board.c"
				}
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp132_ = FALSE;
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp134_ = col;
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp135_ = block_cols;
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp134_ < _tmp135_)) {
#line 152 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 1111 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					row = 0;
#line 1117 "sudoku-board.c"
					{
						gboolean _tmp136_ = FALSE;
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp136_ = TRUE;
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 1124 "sudoku-board.c"
							gint _tmp138_ = 0;
							gint _tmp139_ = 0;
							GeeMap* _tmp140_ = NULL;
							gint _tmp141_ = 0;
							gint _tmp142_ = 0;
							Coord _tmp143_ = {0};
							GeeArrayList* _tmp144_ = NULL;
							GeeArrayList* _tmp145_ = NULL;
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp136_) {
#line 1135 "sudoku-board.c"
								gint _tmp137_ = 0;
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp137_ = row;
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								row = _tmp137_ + 1;
#line 1141 "sudoku-board.c"
							}
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp136_ = FALSE;
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp138_ = row;
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp139_ = block_rows;
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp138_ < _tmp139_)) {
#line 154 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 1153 "sudoku-board.c"
							}
#line 156 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp140_ = self->coords_for_block;
#line 156 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp141_ = row;
#line 156 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp142_ = col;
#line 156 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							coord_init (&_tmp143_, _tmp141_, _tmp142_);
#line 156 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp144_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 156 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp145_ = _tmp144_;
#line 156 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							gee_map_set (_tmp140_, &_tmp143_, (GeeList*) _tmp145_);
#line 156 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_g_object_unref0 (_tmp145_);
#line 1171 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint col = 0;
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		col = 0;
#line 1182 "sudoku-board.c"
		{
			gboolean _tmp146_ = FALSE;
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp146_ = TRUE;
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 1189 "sudoku-board.c"
				gint _tmp148_ = 0;
				gint _tmp149_ = 0;
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp146_) {
#line 1194 "sudoku-board.c"
					gint _tmp147_ = 0;
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp147_ = col;
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					col = _tmp147_ + 1;
#line 1200 "sudoku-board.c"
				}
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp146_ = FALSE;
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp148_ = col;
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp149_ = self->priv->_cols;
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp148_ < _tmp149_)) {
#line 159 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 1212 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					row = 0;
#line 1218 "sudoku-board.c"
					{
						gboolean _tmp150_ = FALSE;
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp150_ = TRUE;
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 1225 "sudoku-board.c"
							gint _tmp152_ = 0;
							gint _tmp153_ = 0;
							GeeMap* _tmp154_ = NULL;
							gint _tmp155_ = 0;
							gint _tmp156_ = 0;
							gint _tmp157_ = 0;
							gint _tmp158_ = 0;
							Coord _tmp159_ = {0};
							gpointer _tmp160_ = NULL;
							GeeList* _tmp161_ = NULL;
							gint _tmp162_ = 0;
							gint _tmp163_ = 0;
							Coord _tmp164_ = {0};
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp150_) {
#line 1241 "sudoku-board.c"
								gint _tmp151_ = 0;
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp151_ = row;
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								row = _tmp151_ + 1;
#line 1247 "sudoku-board.c"
							}
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp150_ = FALSE;
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp152_ = row;
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp153_ = self->priv->_rows;
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp152_ < _tmp153_)) {
#line 161 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 1259 "sudoku-board.c"
							}
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp154_ = self->coords_for_block;
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp155_ = row;
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp156_ = block_rows;
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp157_ = col;
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp158_ = block_cols;
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							coord_init (&_tmp159_, _tmp155_ / _tmp156_, _tmp157_ / _tmp158_);
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp160_ = gee_map_get (_tmp154_, &_tmp159_);
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp161_ = (GeeList*) _tmp160_;
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp162_ = row;
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp163_ = col;
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							coord_init (&_tmp164_, _tmp162_, _tmp163_);
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp161_, &_tmp164_);
#line 163 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_g_object_unref0 (_tmp161_);
#line 1287 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint col = 0;
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		col = 0;
#line 1298 "sudoku-board.c"
		{
			gboolean _tmp165_ = FALSE;
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp165_ = TRUE;
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 1305 "sudoku-board.c"
				gint _tmp167_ = 0;
				gint _tmp168_ = 0;
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp165_) {
#line 1310 "sudoku-board.c"
					gint _tmp166_ = 0;
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp166_ = col;
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					col = _tmp166_ + 1;
#line 1316 "sudoku-board.c"
				}
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp165_ = FALSE;
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp167_ = col;
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp168_ = block_cols;
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp167_ < _tmp168_)) {
#line 166 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 1328 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					row = 0;
#line 1334 "sudoku-board.c"
					{
						gboolean _tmp169_ = FALSE;
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp169_ = TRUE;
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 1341 "sudoku-board.c"
							gint _tmp171_ = 0;
							gint _tmp172_ = 0;
							GeeMap* _tmp173_ = NULL;
							gint _tmp174_ = 0;
							gint _tmp175_ = 0;
							Coord _tmp176_ = {0};
							GeeMap* _tmp177_ = NULL;
							gint _tmp178_ = 0;
							gint _tmp179_ = 0;
							Coord _tmp180_ = {0};
							gpointer _tmp181_ = NULL;
							GeeList* _tmp182_ = NULL;
							GeeList* _tmp183_ = NULL;
							GeeList* _tmp184_ = NULL;
							GeeList* _tmp185_ = NULL;
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp169_) {
#line 1359 "sudoku-board.c"
								gint _tmp170_ = 0;
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp170_ = row;
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								row = _tmp170_ + 1;
#line 1365 "sudoku-board.c"
							}
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp169_ = FALSE;
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp171_ = row;
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp172_ = block_rows;
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp171_ < _tmp172_)) {
#line 168 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 1377 "sudoku-board.c"
							}
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp173_ = self->coords_for_block;
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp174_ = row;
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp175_ = col;
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							coord_init (&_tmp176_, _tmp174_, _tmp175_);
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp177_ = self->coords_for_block;
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp178_ = row;
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp179_ = col;
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							coord_init (&_tmp180_, _tmp178_, _tmp179_);
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp181_ = gee_map_get (_tmp177_, &_tmp180_);
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp182_ = (GeeList*) _tmp181_;
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp183_ = gee_list_get_read_only_view (_tmp182_);
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp184_ = _tmp183_;
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp185_ = _tmp184_;
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							gee_map_set (_tmp173_, &_tmp176_, _tmp185_);
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_g_object_unref0 (_tmp185_);
#line 170 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_g_object_unref0 (_tmp182_);
#line 1411 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 173 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp186_ = self->coords_for_block;
#line 173 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp187_ = gee_map_get_read_only_view (_tmp186_);
#line 173 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp188_ = _tmp187_;
#line 173 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_block);
#line 173 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->coords_for_block = _tmp188_;
#line 94 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return self;
#line 1430 "sudoku-board.c"
}


SudokuBoard* sudoku_board_new (gint block_rows, gint block_cols) {
#line 94 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return sudoku_board_construct (TYPE_SUDOKU_BOARD, block_rows, block_cols);
#line 1437 "sudoku-board.c"
}


static gint* _vala_array_dup1 (gint* self, int length) {
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gint));
#line 1444 "sudoku-board.c"
}


static gboolean* _vala_array_dup2 (gboolean* self, int length) {
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1451 "sudoku-board.c"
}


static gboolean* _vala_array_dup3 (gboolean* self, int length) {
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1458 "sudoku-board.c"
}


static gboolean* _vala_array_dup4 (gboolean* self, int length) {
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1465 "sudoku-board.c"
}


static gboolean* _vala_array_dup5 (gboolean* self, int length) {
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1472 "sudoku-board.c"
}


static gboolean* _vala_array_dup6 (gboolean* self, int length) {
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1479 "sudoku-board.c"
}


SudokuBoard* sudoku_board_clone (SudokuBoard* self) {
	SudokuBoard* result = NULL;
	SudokuBoard* board = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	SudokuBoard* _tmp2_ = NULL;
	gint* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gint _tmp3__length2 = 0;
	gint* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint _tmp4__length2 = 0;
	gboolean* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint _tmp5__length2 = 0;
	gboolean* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	gint _tmp6__length2 = 0;
	gboolean* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gint _tmp7__length2 = 0;
	gboolean* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	gint _tmp8__length2 = 0;
	gboolean* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	gint _tmp9__length2 = 0;
	gboolean* _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	gint _tmp10__length2 = 0;
	gboolean* _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	gint _tmp11__length2 = 0;
	gint _tmp11__length3 = 0;
	gboolean* _tmp12_ = NULL;
	gint _tmp12__length1 = 0;
	gint _tmp12__length2 = 0;
	gint _tmp12__length3 = 0;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	GeeSet* _tmp16_ = NULL;
	GeeSet* _tmp17_ = NULL;
	gboolean* _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	gint _tmp18__length2 = 0;
	gint _tmp18__length3 = 0;
	gboolean* _tmp19_ = NULL;
	gint _tmp19__length1 = 0;
	gint _tmp19__length2 = 0;
	gint _tmp19__length3 = 0;
	DifficultyCategory _tmp20_ = 0;
#line 176 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 178 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 178 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 178 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_new (_tmp0_, _tmp1_);
#line 178 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board = _tmp2_;
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = self->cells;
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3__length1 = self->cells_length1;
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3__length2 = self->cells_length2;
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup1 (_tmp3_, _tmp3__length1 * _tmp3__length2) : ((gpointer) _tmp3_);
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4__length1 = _tmp3__length1;
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4__length2 = _tmp3__length2;
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->cells = (g_free (board->cells), NULL);
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->cells = _tmp4_;
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->cells_length1 = _tmp4__length1;
#line 179 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->cells_length2 = _tmp4__length2;
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5_ = self->is_fixed;
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5__length1 = self->is_fixed_length1;
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5__length2 = self->is_fixed_length2;
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup2 (_tmp5_, _tmp5__length1 * _tmp5__length2) : ((gpointer) _tmp5_);
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp6__length1 = _tmp5__length1;
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp6__length2 = _tmp5__length2;
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->is_fixed = (g_free (board->is_fixed), NULL);
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->is_fixed = _tmp6_;
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->is_fixed_length1 = _tmp6__length1;
#line 180 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->is_fixed_length2 = _tmp6__length2;
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp7_ = self->priv->possible_in_row;
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp7__length1 = self->priv->possible_in_row_length1;
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp7__length2 = self->priv->possible_in_row_length2;
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup3 (_tmp7_, _tmp7__length1 * _tmp7__length2) : ((gpointer) _tmp7_);
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp8__length1 = _tmp7__length1;
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp8__length2 = _tmp7__length2;
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_row = (g_free (board->priv->possible_in_row), NULL);
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_row = _tmp8_;
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_row_length1 = _tmp8__length1;
#line 181 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_row_length2 = _tmp8__length2;
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9_ = self->priv->possible_in_col;
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9__length1 = self->priv->possible_in_col_length1;
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9__length2 = self->priv->possible_in_col_length2;
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup4 (_tmp9_, _tmp9__length1 * _tmp9__length2) : ((gpointer) _tmp9_);
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp10__length1 = _tmp9__length1;
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp10__length2 = _tmp9__length2;
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_col = (g_free (board->priv->possible_in_col), NULL);
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_col = _tmp10_;
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_col_length1 = _tmp10__length1;
#line 182 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_col_length2 = _tmp10__length2;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp11_ = self->priv->possible_in_block;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp11__length1 = self->priv->possible_in_block_length1;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp11__length2 = self->priv->possible_in_block_length2;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp11__length3 = self->priv->possible_in_block_length3;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup5 (_tmp11_, (_tmp11__length1 * _tmp11__length2) * _tmp11__length3) : ((gpointer) _tmp11_);
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp12__length1 = _tmp11__length1;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp12__length2 = _tmp11__length2;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp12__length3 = _tmp11__length3;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_block = (g_free (board->priv->possible_in_block), NULL);
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_block = _tmp12_;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_block_length1 = _tmp12__length1;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_block_length2 = _tmp12__length2;
#line 183 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->possible_in_block_length3 = _tmp12__length3;
#line 184 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp13_ = self->priv->_filled;
#line 184 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	sudoku_board_set_filled (board, _tmp13_);
#line 185 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp14_ = self->priv->_fixed;
#line 185 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	sudoku_board_set_fixed (board, _tmp14_);
#line 186 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp15_ = self->priv->n_earmarks;
#line 186 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->n_earmarks = _tmp15_;
#line 187 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp16_ = board->broken_coords;
#line 187 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp17_ = self->broken_coords;
#line 187 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	gee_collection_add_all ((GeeCollection*) _tmp16_, (GeeCollection*) _tmp17_);
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp18_ = self->priv->earmarks;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp18__length1 = self->priv->earmarks_length1;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp18__length2 = self->priv->earmarks_length2;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp18__length3 = self->priv->earmarks_length3;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp19_ = (_tmp18_ != NULL) ? _vala_array_dup6 (_tmp18_, (_tmp18__length1 * _tmp18__length2) * _tmp18__length3) : ((gpointer) _tmp18_);
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp19__length1 = _tmp18__length1;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp19__length2 = _tmp18__length2;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp19__length3 = _tmp18__length3;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->earmarks = (g_free (board->priv->earmarks), NULL);
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->earmarks = _tmp19_;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->earmarks_length1 = _tmp19__length1;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->earmarks_length2 = _tmp19__length2;
#line 188 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board->priv->earmarks_length3 = _tmp19__length3;
#line 189 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp20_ = self->priv->_difficulty_category;
#line 189 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	sudoku_board_set_difficulty_category (board, _tmp20_);
#line 191 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = board;
#line 191 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 1703 "sudoku-board.c"
}


void sudoku_board_enable_earmark (SudokuBoard* self, gint row, gint column, gint digit) {
	gboolean* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp0__length3 = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gint _tmp11_ = 0;
#line 194 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = row;
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = column;
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = digit;
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = _tmp0_[(((_tmp1_ * _tmp0__length2) + _tmp2_) * _tmp0__length3) + (_tmp3_ - 1)];
#line 197 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (!_tmp4_) {
#line 1737 "sudoku-board.c"
		gboolean* _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		gint _tmp5__length2 = 0;
		gint _tmp5__length3 = 0;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gboolean _tmp9_ = FALSE;
		gint _tmp10_ = 0;
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5_ = self->priv->earmarks;
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length1 = self->priv->earmarks_length1;
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length2 = self->priv->earmarks_length2;
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length3 = self->priv->earmarks_length3;
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp6_ = row;
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp7_ = column;
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp8_ = digit;
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5_[(((_tmp6_ * _tmp5__length2) + _tmp7_) * _tmp5__length3) + (_tmp8_ - 1)] = TRUE;
#line 199 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp9_ = _tmp5_[(((_tmp6_ * _tmp5__length2) + _tmp7_) * _tmp5__length3) + (_tmp8_ - 1)];
#line 200 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp10_ = self->priv->n_earmarks;
#line 200 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		self->priv->n_earmarks = _tmp10_ + 1;
#line 1769 "sudoku-board.c"
	}
#line 194 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp11_ = self->priv->n_earmarks;
#line 194 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_warn_if_fail (_tmp11_ > 0);
#line 1775 "sudoku-board.c"
}


void sudoku_board_disable_earmark (SudokuBoard* self, gint row, gint column, gint digit) {
	gboolean* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp0__length3 = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gint _tmp11_ = 0;
#line 204 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = row;
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = column;
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = digit;
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = _tmp0_[(((_tmp1_ * _tmp0__length2) + _tmp2_) * _tmp0__length3) + (_tmp3_ - 1)];
#line 207 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp4_) {
#line 1809 "sudoku-board.c"
		gboolean* _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		gint _tmp5__length2 = 0;
		gint _tmp5__length3 = 0;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gboolean _tmp9_ = FALSE;
		gint _tmp10_ = 0;
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5_ = self->priv->earmarks;
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length1 = self->priv->earmarks_length1;
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length2 = self->priv->earmarks_length2;
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length3 = self->priv->earmarks_length3;
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp6_ = row;
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp7_ = column;
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp8_ = digit;
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5_[(((_tmp6_ * _tmp5__length2) + _tmp7_) * _tmp5__length3) + (_tmp8_ - 1)] = FALSE;
#line 209 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp9_ = _tmp5_[(((_tmp6_ * _tmp5__length2) + _tmp7_) * _tmp5__length3) + (_tmp8_ - 1)];
#line 210 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp10_ = self->priv->n_earmarks;
#line 210 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		self->priv->n_earmarks = _tmp10_ - 1;
#line 1841 "sudoku-board.c"
	}
#line 204 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp11_ = self->priv->n_earmarks;
#line 204 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_warn_if_fail (_tmp11_ >= 0);
#line 1847 "sudoku-board.c"
}


gboolean sudoku_board_is_earmark_enabled (SudokuBoard* self, gint row, gint column, gint digit) {
	gboolean result = FALSE;
	gboolean* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp0__length3 = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
#line 214 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = row;
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = column;
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = digit;
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = _tmp0_[(((_tmp1_ * _tmp0__length2) + _tmp2_) * _tmp0__length3) + (_tmp3_ - 1)];
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp4_;
#line 216 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 1883 "sudoku-board.c"
}


gboolean sudoku_board_is_possible (SudokuBoard* self, gint row, gint col, gint val) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gint _tmp3__length2 = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
#line 219 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 221 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = val;
#line 221 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	val = _tmp0_ - 1;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = self->priv->possible_in_row;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3__length1 = self->priv->possible_in_row_length1;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3__length2 = self->priv->possible_in_row_length2;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = row;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5_ = val;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp6_ = _tmp3_[(_tmp4_ * _tmp3__length2) + _tmp5_];
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp6_) {
#line 1918 "sudoku-board.c"
		gboolean* _tmp7_ = NULL;
		gint _tmp7__length1 = 0;
		gint _tmp7__length2 = 0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gboolean _tmp10_ = FALSE;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp7_ = self->priv->possible_in_col;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp7__length1 = self->priv->possible_in_col_length1;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp7__length2 = self->priv->possible_in_col_length2;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp8_ = col;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp9_ = val;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp10_ = _tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_];
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp2_ = _tmp10_;
#line 1939 "sudoku-board.c"
	} else {
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp2_ = FALSE;
#line 1943 "sudoku-board.c"
	}
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp2_) {
#line 1947 "sudoku-board.c"
		gboolean* _tmp11_ = NULL;
		gint _tmp11__length1 = 0;
		gint _tmp11__length2 = 0;
		gint _tmp11__length3 = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gboolean _tmp17_ = FALSE;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp11_ = self->priv->possible_in_block;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp11__length1 = self->priv->possible_in_block_length1;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp11__length2 = self->priv->possible_in_block_length2;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp11__length3 = self->priv->possible_in_block_length3;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp12_ = row;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp13_ = self->priv->_block_cols;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp14_ = col;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp15_ = self->priv->_block_rows;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp16_ = val;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp17_ = _tmp11_[((((_tmp12_ / _tmp13_) * _tmp11__length2) + (_tmp14_ / _tmp15_)) * _tmp11__length3) + _tmp16_];
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp1_ = _tmp17_;
#line 1980 "sudoku-board.c"
	} else {
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp1_ = FALSE;
#line 1984 "sudoku-board.c"
	}
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp1_;
#line 222 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 1990 "sudoku-board.c"
}


gint sudoku_board_count_possibilities (SudokuBoard* self, gint row, gint col) {
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint* _tmp3_ = NULL;
	gint* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint _tmp5_ = 0;
#line 225 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 227 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = row;
#line 227 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = col;
#line 227 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = sudoku_board_get_possibilities (self, _tmp0_, _tmp1_, &_tmp2_);
#line 227 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = _tmp3_;
#line 227 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4__length1 = _tmp2_;
#line 227 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5_ = _tmp2_;
#line 227 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = (g_free (_tmp4_), NULL);
#line 227 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp5_;
#line 227 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 2023 "sudoku-board.c"
}


static gint* _vala_array_dup7 (gint* self, int length) {
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gint));
#line 2030 "sudoku-board.c"
}


gint* sudoku_board_get_possibilities (SudokuBoard* self, gint row, gint col, int* result_length1) {
	gint* result = NULL;
	gint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint* possibilities = NULL;
	gint* _tmp6_ = NULL;
	gint possibilities_length1 = 0;
	gint _possibilities_size_ = 0;
	gint count = 0;
	gint* _tmp21_ = NULL;
	gint _tmp21__length1 = 0;
	gint _tmp22_ = 0;
	gint* _tmp23_ = NULL;
	gint _tmp23__length1 = 0;
	gint* _tmp24_ = NULL;
	gint _tmp24__length1 = 0;
#line 230 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 232 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 232 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 232 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 232 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = row;
#line 232 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = col;
#line 232 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 232 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp3_ != 0) {
#line 2070 "sudoku-board.c"
		gint* _tmp4_ = NULL;
		gint* _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
#line 233 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp4_ = g_new0 (gint, 0);
#line 233 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5_ = _tmp4_;
#line 233 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length1 = 0;
#line 233 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		if (result_length1) {
#line 233 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			*result_length1 = _tmp5__length1;
#line 2084 "sudoku-board.c"
		}
#line 233 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		result = _tmp5_;
#line 233 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		return result;
#line 2090 "sudoku-board.c"
	}
#line 235 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp6_ = g_new0 (gint, 9);
#line 235 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	possibilities = _tmp6_;
#line 235 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	possibilities_length1 = 9;
#line 235 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_possibilities_size_ = possibilities_length1;
#line 236 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	count = 0;
#line 2102 "sudoku-board.c"
	{
		gint l = 0;
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		l = 1;
#line 2107 "sudoku-board.c"
		{
			gboolean _tmp7_ = FALSE;
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp7_ = TRUE;
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 2114 "sudoku-board.c"
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
				gboolean _tmp15_ = FALSE;
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp7_) {
#line 2124 "sudoku-board.c"
					gint _tmp8_ = 0;
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp8_ = l;
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l = _tmp8_ + 1;
#line 2130 "sudoku-board.c"
				}
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp7_ = FALSE;
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp9_ = l;
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp10_ = sudoku_board_get_max_val (self);
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp11_ = _tmp10_;
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp9_ <= _tmp11_)) {
#line 238 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 2144 "sudoku-board.c"
				}
#line 240 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp12_ = row;
#line 240 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp13_ = col;
#line 240 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp14_ = l;
#line 240 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp15_ = sudoku_board_is_possible (self, _tmp12_, _tmp13_, _tmp14_);
#line 240 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (_tmp15_) {
#line 2156 "sudoku-board.c"
					gint* _tmp16_ = NULL;
					gint _tmp16__length1 = 0;
					gint _tmp17_ = 0;
					gint _tmp18_ = 0;
					gint _tmp19_ = 0;
					gint _tmp20_ = 0;
#line 241 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp16_ = possibilities;
#line 241 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp16__length1 = possibilities_length1;
#line 241 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp17_ = count;
#line 241 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp18_ = l;
#line 241 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp16_[_tmp17_] = _tmp18_;
#line 241 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp19_ = _tmp16_[_tmp17_];
#line 242 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp20_ = count;
#line 242 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					count = _tmp20_ + 1;
#line 2179 "sudoku-board.c"
				}
			}
		}
	}
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp21_ = possibilities;
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp21__length1 = possibilities_length1;
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp22_ = count;
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp23_ = ((_tmp21_ + 0) != NULL) ? _vala_array_dup7 (_tmp21_ + 0, _tmp22_ - 0) : ((gpointer) (_tmp21_ + 0));
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp23__length1 = _tmp22_ - 0;
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp24_ = _tmp23_;
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp24__length1 = _tmp23__length1;
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (result_length1) {
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		*result_length1 = _tmp24__length1;
#line 2202 "sudoku-board.c"
	}
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp24_;
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	possibilities = (g_free (possibilities), NULL);
#line 245 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 2210 "sudoku-board.c"
}


gboolean* sudoku_board_get_possibilities_as_bool_array (SudokuBoard* self, gint row, gint col, int* result_length1) {
	gboolean* result = NULL;
	gboolean* possibilities = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gboolean* _tmp2_ = NULL;
	gint possibilities_length1 = 0;
	gint _possibilities_size_ = 0;
	gboolean* _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
#line 248 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 250 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 250 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 250 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gboolean, _tmp1_);
#line 250 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	possibilities = _tmp2_;
#line 250 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	possibilities_length1 = _tmp1_;
#line 250 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_possibilities_size_ = possibilities_length1;
#line 2238 "sudoku-board.c"
	{
		gint l = 0;
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		l = 1;
#line 2243 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 2250 "sudoku-board.c"
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
				gboolean* _tmp8_ = NULL;
				gint _tmp8__length1 = 0;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 2264 "sudoku-board.c"
					gint _tmp4_ = 0;
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp4_ = l;
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l = _tmp4_ + 1;
#line 2270 "sudoku-board.c"
				}
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp5_ = l;
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp6_ = sudoku_board_get_max_val (self);
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp7_ = _tmp6_;
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp5_ <= _tmp7_)) {
#line 252 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 2284 "sudoku-board.c"
				}
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp8_ = possibilities;
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp8__length1 = possibilities_length1;
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp9_ = l;
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp10_ = row;
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp11_ = col;
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp12_ = l;
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp13_ = sudoku_board_is_possible (self, _tmp10_, _tmp11_, _tmp12_);
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp8_[_tmp9_ - 1] = _tmp13_;
#line 254 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp14_ = _tmp8_[_tmp9_ - 1];
#line 2304 "sudoku-board.c"
			}
		}
	}
#line 257 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp15_ = possibilities;
#line 257 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp15__length1 = possibilities_length1;
#line 257 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (result_length1) {
#line 257 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		*result_length1 = _tmp15__length1;
#line 2316 "sudoku-board.c"
	}
#line 257 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp15_;
#line 257 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 2322 "sudoku-board.c"
}


void sudoku_board_get_block_for (SudokuBoard* self, gint row, gint col, Coord* result) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	Coord _tmp4_ = {0};
#line 260 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 262 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = row;
#line 262 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_rows;
#line 262 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = col;
#line 262 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = self->priv->_block_cols;
#line 262 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	coord_init (&_tmp4_, _tmp0_ / _tmp1_, _tmp2_ / _tmp3_);
#line 262 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	*result = _tmp4_;
#line 262 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return;
#line 2348 "sudoku-board.c"
}


void sudoku_board_insert (SudokuBoard* self, gint row, gint col, gint val, gboolean is_fixed) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gint* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	gint _tmp9__length2 = 0;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gint* _tmp16_ = NULL;
	gint _tmp16__length1 = 0;
	gint _tmp16__length2 = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	gint _tmp20_ = 0;
	gboolean* _tmp21_ = NULL;
	gint _tmp21__length1 = 0;
	gint _tmp21__length2 = 0;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gint _tmp26_ = 0;
	gboolean _tmp27_ = FALSE;
	gboolean* _tmp29_ = NULL;
	gint _tmp29__length1 = 0;
	gint _tmp29__length2 = 0;
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	gboolean _tmp32_ = FALSE;
	gboolean* _tmp38_ = NULL;
	gint _tmp38__length1 = 0;
	gint _tmp38__length2 = 0;
	gint _tmp39_ = 0;
	gint _tmp40_ = 0;
	gboolean _tmp41_ = FALSE;
	gboolean* _tmp47_ = NULL;
	gint _tmp47__length1 = 0;
	gint _tmp47__length2 = 0;
	gint _tmp47__length3 = 0;
	gint _tmp48_ = 0;
	gint _tmp49_ = 0;
	gint _tmp50_ = 0;
	gint _tmp51_ = 0;
	gint _tmp52_ = 0;
	gboolean _tmp53_ = FALSE;
	gint _tmp63_ = 0;
	gboolean* _tmp64_ = NULL;
	gint _tmp64__length1 = 0;
	gint _tmp64__length2 = 0;
	gint _tmp65_ = 0;
	gint _tmp66_ = 0;
	gboolean _tmp67_ = FALSE;
	gboolean* _tmp68_ = NULL;
	gint _tmp68__length1 = 0;
	gint _tmp68__length2 = 0;
	gint _tmp69_ = 0;
	gint _tmp70_ = 0;
	gboolean _tmp71_ = FALSE;
	gboolean* _tmp72_ = NULL;
	gint _tmp72__length1 = 0;
	gint _tmp72__length2 = 0;
	gint _tmp72__length3 = 0;
	gint _tmp73_ = 0;
	gint _tmp74_ = 0;
	gint _tmp75_ = 0;
	gint _tmp76_ = 0;
	gint _tmp77_ = 0;
	gboolean _tmp78_ = FALSE;
	gboolean _tmp79_ = FALSE;
	gboolean _tmp80_ = FALSE;
#line 265 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 268 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = val;
#line 268 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_vala_assert (_tmp0_ > 0, "val > 0");
#line 269 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = val;
#line 269 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_get_max_val (self);
#line 269 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = _tmp2_;
#line 269 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_vala_assert (_tmp1_ <= _tmp3_, "val <= max_val");
#line 272 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = is_fixed;
#line 272 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (!_tmp4_) {
#line 2445 "sudoku-board.c"
		gboolean* _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		gint _tmp5__length2 = 0;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gboolean _tmp8_ = FALSE;
#line 273 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5_ = self->is_fixed;
#line 273 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length1 = self->is_fixed_length1;
#line 273 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length2 = self->is_fixed_length2;
#line 273 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp6_ = row;
#line 273 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp7_ = col;
#line 273 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp8_ = _tmp5_[(_tmp6_ * _tmp5__length2) + _tmp7_];
#line 273 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_vala_assert (!_tmp8_, "!this.is_fixed[row, col]");
#line 2466 "sudoku-board.c"
	}
#line 276 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9_ = self->cells;
#line 276 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9__length1 = self->cells_length1;
#line 276 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9__length2 = self->cells_length2;
#line 276 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp10_ = row;
#line 276 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp11_ = col;
#line 276 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp12_ = _tmp9_[(_tmp10_ * _tmp9__length2) + _tmp11_];
#line 276 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp12_ != 0) {
#line 2482 "sudoku-board.c"
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gboolean _tmp15_ = FALSE;
#line 277 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp13_ = row;
#line 277 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp14_ = col;
#line 277 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp15_ = is_fixed;
#line 277 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_remove (self, _tmp13_, _tmp14_, _tmp15_);
#line 2494 "sudoku-board.c"
	}
#line 279 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp16_ = self->cells;
#line 279 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp16__length1 = self->cells_length1;
#line 279 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp16__length2 = self->cells_length2;
#line 279 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp17_ = row;
#line 279 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp18_ = col;
#line 279 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp19_ = val;
#line 279 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp16_[(_tmp17_ * _tmp16__length2) + _tmp18_] = _tmp19_;
#line 279 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp20_ = _tmp16_[(_tmp17_ * _tmp16__length2) + _tmp18_];
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp21_ = self->is_fixed;
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp21__length1 = self->is_fixed_length1;
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp21__length2 = self->is_fixed_length2;
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp22_ = row;
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp23_ = col;
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp24_ = is_fixed;
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp21_[(_tmp22_ * _tmp21__length2) + _tmp23_] = _tmp24_;
#line 280 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp25_ = _tmp21_[(_tmp22_ * _tmp21__length2) + _tmp23_];
#line 281 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp26_ = self->priv->_filled;
#line 281 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	sudoku_board_set_filled (self, _tmp26_ + 1);
#line 282 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp27_ = is_fixed;
#line 282 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp27_) {
#line 2536 "sudoku-board.c"
		gint _tmp28_ = 0;
#line 283 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp28_ = self->priv->_fixed;
#line 283 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, _tmp28_ + 1);
#line 2542 "sudoku-board.c"
	}
#line 285 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp29_ = self->priv->possible_in_row;
#line 285 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp29__length1 = self->priv->possible_in_row_length1;
#line 285 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp29__length2 = self->priv->possible_in_row_length2;
#line 285 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp30_ = row;
#line 285 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp31_ = val;
#line 285 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp32_ = _tmp29_[(_tmp30_ * _tmp29__length2) + (_tmp31_ - 1)];
#line 285 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (!_tmp32_) {
#line 2558 "sudoku-board.c"
		GeeList* _tmp33_ = NULL;
		gint _tmp34_ = 0;
		gpointer _tmp35_ = NULL;
		GeeList* _tmp36_ = NULL;
		gint _tmp37_ = 0;
#line 287 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp33_ = self->coords_for_row;
#line 287 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp34_ = row;
#line 287 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp35_ = gee_list_get (_tmp33_, _tmp34_);
#line 287 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp36_ = (GeeList*) _tmp35_;
#line 287 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp37_ = val;
#line 287 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp36_, _tmp37_);
#line 287 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp36_);
#line 2578 "sudoku-board.c"
	}
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp38_ = self->priv->possible_in_col;
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp38__length1 = self->priv->possible_in_col_length1;
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp38__length2 = self->priv->possible_in_col_length2;
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp39_ = col;
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp40_ = val;
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp41_ = _tmp38_[(_tmp39_ * _tmp38__length2) + (_tmp40_ - 1)];
#line 290 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (!_tmp41_) {
#line 2594 "sudoku-board.c"
		GeeList* _tmp42_ = NULL;
		gint _tmp43_ = 0;
		gpointer _tmp44_ = NULL;
		GeeList* _tmp45_ = NULL;
		gint _tmp46_ = 0;
#line 292 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp42_ = self->coords_for_col;
#line 292 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp43_ = col;
#line 292 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp44_ = gee_list_get (_tmp42_, _tmp43_);
#line 292 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp45_ = (GeeList*) _tmp44_;
#line 292 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp46_ = val;
#line 292 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp45_, _tmp46_);
#line 292 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp45_);
#line 2614 "sudoku-board.c"
	}
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp47_ = self->priv->possible_in_block;
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp47__length1 = self->priv->possible_in_block_length1;
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp47__length2 = self->priv->possible_in_block_length2;
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp47__length3 = self->priv->possible_in_block_length3;
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp48_ = row;
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp49_ = self->priv->_block_cols;
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp50_ = col;
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp51_ = self->priv->_block_rows;
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp52_ = val;
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp53_ = _tmp47_[((((_tmp48_ / _tmp49_) * _tmp47__length2) + (_tmp50_ / _tmp51_)) * _tmp47__length3) + (_tmp52_ - 1)];
#line 295 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (!_tmp53_) {
#line 2638 "sudoku-board.c"
		GeeMap* _tmp54_ = NULL;
		gint _tmp55_ = 0;
		gint _tmp56_ = 0;
		gint _tmp57_ = 0;
		gint _tmp58_ = 0;
		Coord _tmp59_ = {0};
		gpointer _tmp60_ = NULL;
		GeeList* _tmp61_ = NULL;
		gint _tmp62_ = 0;
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp54_ = self->coords_for_block;
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp55_ = row;
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp56_ = self->priv->_block_cols;
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp57_ = col;
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp58_ = self->priv->_block_rows;
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		coord_init (&_tmp59_, _tmp55_ / _tmp56_, _tmp57_ / _tmp58_);
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp60_ = gee_map_get (_tmp54_, &_tmp59_);
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp61_ = (GeeList*) _tmp60_;
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp62_ = val;
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp61_, _tmp62_);
#line 297 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp61_);
#line 2670 "sudoku-board.c"
	}
#line 301 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp63_ = val;
#line 301 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	val = _tmp63_ - 1;
#line 302 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp64_ = self->priv->possible_in_row;
#line 302 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp64__length1 = self->priv->possible_in_row_length1;
#line 302 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp64__length2 = self->priv->possible_in_row_length2;
#line 302 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp65_ = row;
#line 302 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp66_ = val;
#line 302 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp64_[(_tmp65_ * _tmp64__length2) + _tmp66_] = FALSE;
#line 302 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp67_ = _tmp64_[(_tmp65_ * _tmp64__length2) + _tmp66_];
#line 303 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp68_ = self->priv->possible_in_col;
#line 303 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp68__length1 = self->priv->possible_in_col_length1;
#line 303 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp68__length2 = self->priv->possible_in_col_length2;
#line 303 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp69_ = col;
#line 303 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp70_ = val;
#line 303 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp68_[(_tmp69_ * _tmp68__length2) + _tmp70_] = FALSE;
#line 303 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp71_ = _tmp68_[(_tmp69_ * _tmp68__length2) + _tmp70_];
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp72_ = self->priv->possible_in_block;
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp72__length1 = self->priv->possible_in_block_length1;
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp72__length2 = self->priv->possible_in_block_length2;
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp72__length3 = self->priv->possible_in_block_length3;
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp73_ = row;
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp74_ = self->priv->_block_cols;
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp75_ = col;
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp76_ = self->priv->_block_rows;
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp77_ = val;
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp72_[((((_tmp73_ / _tmp74_) * _tmp72__length2) + (_tmp75_ / _tmp76_)) * _tmp72__length3) + _tmp77_] = FALSE;
#line 304 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp78_ = _tmp72_[((((_tmp73_ / _tmp74_) * _tmp72__length2) + (_tmp75_ / _tmp76_)) * _tmp72__length3) + _tmp77_];
#line 306 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp79_ = sudoku_board_get_complete (self);
#line 306 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp80_ = _tmp79_;
#line 306 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp80_) {
#line 307 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_signal_emit_by_name (self, "completed");
#line 2734 "sudoku-board.c"
	}
}


void sudoku_board_set (SudokuBoard* self, gint row, gint col, gint val) {
	gint _tmp0_ = 0;
#line 310 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 312 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = val;
#line 312 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp0_ == 0) {
#line 2747 "sudoku-board.c"
		gint _tmp1_ = 0;
		gint _tmp2_ = 0;
#line 314 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp1_ = row;
#line 314 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp2_ = col;
#line 314 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_remove (self, _tmp1_, _tmp2_, FALSE);
#line 2756 "sudoku-board.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gint _tmp4_ = 0;
#line 316 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp4_ = val;
#line 316 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		if (_tmp4_ > 0) {
#line 2764 "sudoku-board.c"
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
#line 316 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp5_ = val;
#line 316 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp6_ = sudoku_board_get_max_val (self);
#line 316 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp7_ = _tmp6_;
#line 316 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp3_ = _tmp5_ <= _tmp7_;
#line 2776 "sudoku-board.c"
		} else {
#line 316 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp3_ = FALSE;
#line 2780 "sudoku-board.c"
		}
#line 316 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		if (_tmp3_) {
#line 2784 "sudoku-board.c"
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			gint _tmp10_ = 0;
#line 318 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp8_ = row;
#line 318 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp9_ = col;
#line 318 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp10_ = val;
#line 318 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			sudoku_board_insert (self, _tmp8_, _tmp9_, _tmp10_, FALSE);
#line 2796 "sudoku-board.c"
		} else {
#line 322 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 2800 "sudoku-board.c"
		}
	}
}


gint sudoku_board_get (SudokuBoard* self, gint row, gint col) {
	gint result = 0;
	gint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 326 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 328 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 328 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 328 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 328 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = row;
#line 328 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = col;
#line 328 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 328 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp3_;
#line 328 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 2832 "sudoku-board.c"
}


void sudoku_board_remove (SudokuBoard* self, gint row, gint col, gboolean is_fixed) {
	gint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gint previous_val = 0;
	gint* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	gint _tmp9__length2 = 0;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gint* _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	gint _tmp13__length2 = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	GeeSet* _tmp17_ = NULL;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	Coord _tmp20_ = {0};
	gboolean _tmp21_ = FALSE;
	gint _tmp126_ = 0;
#line 331 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 334 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 334 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 334 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 334 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = row;
#line 334 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = col;
#line 334 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 334 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp3_ == 0) {
#line 335 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		return;
#line 2881 "sudoku-board.c"
	}
#line 338 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = is_fixed;
#line 338 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (!_tmp4_) {
#line 2887 "sudoku-board.c"
		gboolean* _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		gint _tmp5__length2 = 0;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gboolean _tmp8_ = FALSE;
#line 339 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5_ = self->is_fixed;
#line 339 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length1 = self->is_fixed_length1;
#line 339 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5__length2 = self->is_fixed_length2;
#line 339 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp6_ = row;
#line 339 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp7_ = col;
#line 339 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp8_ = _tmp5_[(_tmp6_ * _tmp5__length2) + _tmp7_];
#line 339 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_vala_assert (!_tmp8_, "!this.is_fixed[row, col]");
#line 2908 "sudoku-board.c"
	}
#line 341 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9_ = self->cells;
#line 341 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9__length1 = self->cells_length1;
#line 341 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9__length2 = self->cells_length2;
#line 341 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp10_ = row;
#line 341 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp11_ = col;
#line 341 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp12_ = _tmp9_[(_tmp10_ * _tmp9__length2) + _tmp11_];
#line 341 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	previous_val = _tmp12_;
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp13_ = self->cells;
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp13__length1 = self->cells_length1;
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp13__length2 = self->cells_length2;
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp14_ = row;
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp15_ = col;
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp13_[(_tmp14_ * _tmp13__length2) + _tmp15_] = 0;
#line 342 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp16_ = _tmp13_[(_tmp14_ * _tmp13__length2) + _tmp15_];
#line 344 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp17_ = self->broken_coords;
#line 344 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp18_ = row;
#line 344 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp19_ = col;
#line 344 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	coord_init (&_tmp20_, _tmp18_, _tmp19_);
#line 344 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp21_ = gee_collection_contains ((GeeCollection*) _tmp17_, &_tmp20_);
#line 344 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp21_) {
#line 2950 "sudoku-board.c"
		GeeList* _tmp22_ = NULL;
		gint _tmp23_ = 0;
		gpointer _tmp24_ = NULL;
		GeeList* _tmp25_ = NULL;
		gint _tmp26_ = 0;
		GeeList* _tmp27_ = NULL;
		gint _tmp28_ = 0;
		gpointer _tmp29_ = NULL;
		GeeList* _tmp30_ = NULL;
		gint _tmp31_ = 0;
		GeeMap* _tmp32_ = NULL;
		gint _tmp33_ = 0;
		gint _tmp34_ = 0;
		gint _tmp35_ = 0;
		gint _tmp36_ = 0;
		Coord _tmp37_ = {0};
		gpointer _tmp38_ = NULL;
		GeeList* _tmp39_ = NULL;
		gint _tmp40_ = 0;
		GeeSet* _tmp41_ = NULL;
		gint _tmp42_ = 0;
		gint _tmp43_ = 0;
		Coord _tmp44_ = {0};
		GeeList* _tmp45_ = NULL;
		gint _tmp46_ = 0;
		gpointer _tmp47_ = NULL;
		GeeList* _tmp48_ = NULL;
		gint _tmp49_ = 0;
		GeeList* _tmp50_ = NULL;
		gint _tmp51_ = 0;
		gpointer _tmp52_ = NULL;
		GeeList* _tmp53_ = NULL;
		gint _tmp54_ = 0;
		GeeMap* _tmp55_ = NULL;
		gint _tmp56_ = 0;
		gint _tmp57_ = 0;
		gint _tmp58_ = 0;
		gint _tmp59_ = 0;
		Coord _tmp60_ = {0};
		gpointer _tmp61_ = NULL;
		GeeList* _tmp62_ = NULL;
		gint _tmp63_ = 0;
		gboolean* _tmp64_ = NULL;
		gint _tmp64__length1 = 0;
		gint _tmp64__length2 = 0;
		gint _tmp65_ = 0;
		gint _tmp66_ = 0;
		GeeList* _tmp67_ = NULL;
		gint _tmp68_ = 0;
		gpointer _tmp69_ = NULL;
		GeeList* _tmp70_ = NULL;
		gint _tmp71_ = 0;
		GeeSet* _tmp72_ = NULL;
		GeeSet* _tmp73_ = NULL;
		gint _tmp74_ = 0;
		gint _tmp75_ = 0;
		gboolean _tmp76_ = FALSE;
		gboolean* _tmp77_ = NULL;
		gint _tmp77__length1 = 0;
		gint _tmp77__length2 = 0;
		gint _tmp78_ = 0;
		gint _tmp79_ = 0;
		GeeList* _tmp80_ = NULL;
		gint _tmp81_ = 0;
		gpointer _tmp82_ = NULL;
		GeeList* _tmp83_ = NULL;
		gint _tmp84_ = 0;
		GeeSet* _tmp85_ = NULL;
		GeeSet* _tmp86_ = NULL;
		gint _tmp87_ = 0;
		gint _tmp88_ = 0;
		gboolean _tmp89_ = FALSE;
		gboolean* _tmp90_ = NULL;
		gint _tmp90__length1 = 0;
		gint _tmp90__length2 = 0;
		gint _tmp90__length3 = 0;
		gint _tmp91_ = 0;
		gint _tmp92_ = 0;
		gint _tmp93_ = 0;
		gint _tmp94_ = 0;
		gint _tmp95_ = 0;
		GeeMap* _tmp96_ = NULL;
		gint _tmp97_ = 0;
		gint _tmp98_ = 0;
		gint _tmp99_ = 0;
		gint _tmp100_ = 0;
		Coord _tmp101_ = {0};
		gpointer _tmp102_ = NULL;
		GeeList* _tmp103_ = NULL;
		gint _tmp104_ = 0;
		GeeSet* _tmp105_ = NULL;
		GeeSet* _tmp106_ = NULL;
		gint _tmp107_ = 0;
		gint _tmp108_ = 0;
		gboolean _tmp109_ = FALSE;
#line 347 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp22_ = self->coords_for_row;
#line 347 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp23_ = row;
#line 347 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp24_ = gee_list_get (_tmp22_, _tmp23_);
#line 347 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp25_ = (GeeList*) _tmp24_;
#line 347 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp26_ = previous_val;
#line 347 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp25_, _tmp26_);
#line 347 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp25_);
#line 348 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp27_ = self->coords_for_col;
#line 348 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp28_ = col;
#line 348 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp29_ = gee_list_get (_tmp27_, _tmp28_);
#line 348 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp30_ = (GeeList*) _tmp29_;
#line 348 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp31_ = previous_val;
#line 348 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp30_, _tmp31_);
#line 348 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp30_);
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp32_ = self->coords_for_block;
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp33_ = row;
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp34_ = self->priv->_block_rows;
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp35_ = col;
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp36_ = self->priv->_block_cols;
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		coord_init (&_tmp37_, _tmp33_ / _tmp34_, _tmp35_ / _tmp36_);
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp38_ = gee_map_get (_tmp32_, &_tmp37_);
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp39_ = (GeeList*) _tmp38_;
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp40_ = previous_val;
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp39_, _tmp40_);
#line 349 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp39_);
#line 350 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp41_ = self->broken_coords;
#line 350 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp42_ = row;
#line 350 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp43_ = col;
#line 350 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		coord_init (&_tmp44_, _tmp42_, _tmp43_);
#line 350 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		gee_collection_remove ((GeeCollection*) _tmp41_, &_tmp44_);
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp45_ = self->coords_for_row;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp46_ = row;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp47_ = gee_list_get (_tmp45_, _tmp46_);
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp48_ = (GeeList*) _tmp47_;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp49_ = previous_val;
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp48_, _tmp49_);
#line 353 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp48_);
#line 354 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp50_ = self->coords_for_col;
#line 354 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp51_ = col;
#line 354 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp52_ = gee_list_get (_tmp50_, _tmp51_);
#line 354 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp53_ = (GeeList*) _tmp52_;
#line 354 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp54_ = previous_val;
#line 354 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp53_, _tmp54_);
#line 354 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp53_);
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp55_ = self->coords_for_block;
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp56_ = row;
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp57_ = self->priv->_block_rows;
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp58_ = col;
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp59_ = self->priv->_block_cols;
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		coord_init (&_tmp60_, _tmp56_ / _tmp57_, _tmp58_ / _tmp59_);
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp61_ = gee_map_get (_tmp55_, &_tmp60_);
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp62_ = (GeeList*) _tmp61_;
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp63_ = previous_val;
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp62_, _tmp63_);
#line 355 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp62_);
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp64_ = self->priv->possible_in_row;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp64__length1 = self->priv->possible_in_row_length1;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp64__length2 = self->priv->possible_in_row_length2;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp65_ = row;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp66_ = previous_val;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp67_ = self->coords_for_row;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp68_ = row;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp69_ = gee_list_get (_tmp67_, _tmp68_);
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp70_ = (GeeList*) _tmp69_;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp71_ = previous_val;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp72_ = sudoku_board_get_occurances (self, _tmp70_, _tmp71_);
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp73_ = _tmp72_;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp74_ = gee_collection_get_size ((GeeCollection*) _tmp73_);
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp75_ = _tmp74_;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp64_[(_tmp65_ * _tmp64__length2) + (_tmp66_ - 1)] = _tmp75_ == 0;
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp76_ = _tmp64_[(_tmp65_ * _tmp64__length2) + (_tmp66_ - 1)];
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp73_);
#line 358 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp70_);
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp77_ = self->priv->possible_in_col;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp77__length1 = self->priv->possible_in_col_length1;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp77__length2 = self->priv->possible_in_col_length2;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp78_ = col;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp79_ = previous_val;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp80_ = self->coords_for_col;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp81_ = col;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp82_ = gee_list_get (_tmp80_, _tmp81_);
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp83_ = (GeeList*) _tmp82_;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp84_ = previous_val;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp85_ = sudoku_board_get_occurances (self, _tmp83_, _tmp84_);
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp86_ = _tmp85_;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp87_ = gee_collection_get_size ((GeeCollection*) _tmp86_);
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp88_ = _tmp87_;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp77_[(_tmp78_ * _tmp77__length2) + (_tmp79_ - 1)] = _tmp88_ == 0;
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp89_ = _tmp77_[(_tmp78_ * _tmp77__length2) + (_tmp79_ - 1)];
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp86_);
#line 359 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp83_);
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp90_ = self->priv->possible_in_block;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp90__length1 = self->priv->possible_in_block_length1;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp90__length2 = self->priv->possible_in_block_length2;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp90__length3 = self->priv->possible_in_block_length3;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp91_ = row;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp92_ = self->priv->_block_cols;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp93_ = col;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp94_ = self->priv->_block_rows;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp95_ = previous_val;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp96_ = self->coords_for_block;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp97_ = row;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp98_ = self->priv->_block_rows;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp99_ = col;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp100_ = self->priv->_block_cols;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		coord_init (&_tmp101_, _tmp97_ / _tmp98_, _tmp99_ / _tmp100_);
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp102_ = gee_map_get (_tmp96_, &_tmp101_);
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp103_ = (GeeList*) _tmp102_;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp104_ = previous_val;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp105_ = sudoku_board_get_occurances (self, _tmp103_, _tmp104_);
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp106_ = _tmp105_;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp107_ = gee_collection_get_size ((GeeCollection*) _tmp106_);
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp108_ = _tmp107_;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp90_[((((_tmp91_ / _tmp92_) * _tmp90__length2) + (_tmp93_ / _tmp94_)) * _tmp90__length3) + (_tmp95_ - 1)] = _tmp108_ == 0;
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp109_ = _tmp90_[((((_tmp91_ / _tmp92_) * _tmp90__length2) + (_tmp93_ / _tmp94_)) * _tmp90__length3) + (_tmp95_ - 1)];
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp106_);
#line 360 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_tmp103_);
#line 3280 "sudoku-board.c"
	} else {
		gint _tmp110_ = 0;
		gboolean* _tmp111_ = NULL;
		gint _tmp111__length1 = 0;
		gint _tmp111__length2 = 0;
		gint _tmp112_ = 0;
		gint _tmp113_ = 0;
		gboolean _tmp114_ = FALSE;
		gboolean* _tmp115_ = NULL;
		gint _tmp115__length1 = 0;
		gint _tmp115__length2 = 0;
		gint _tmp116_ = 0;
		gint _tmp117_ = 0;
		gboolean _tmp118_ = FALSE;
		gboolean* _tmp119_ = NULL;
		gint _tmp119__length1 = 0;
		gint _tmp119__length2 = 0;
		gint _tmp119__length3 = 0;
		gint _tmp120_ = 0;
		gint _tmp121_ = 0;
		gint _tmp122_ = 0;
		gint _tmp123_ = 0;
		gint _tmp124_ = 0;
		gboolean _tmp125_ = FALSE;
#line 364 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp110_ = previous_val;
#line 364 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		previous_val = _tmp110_ - 1;
#line 366 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp111_ = self->priv->possible_in_row;
#line 366 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp111__length1 = self->priv->possible_in_row_length1;
#line 366 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp111__length2 = self->priv->possible_in_row_length2;
#line 366 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp112_ = row;
#line 366 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp113_ = previous_val;
#line 366 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp111_[(_tmp112_ * _tmp111__length2) + _tmp113_] = TRUE;
#line 366 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp114_ = _tmp111_[(_tmp112_ * _tmp111__length2) + _tmp113_];
#line 367 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp115_ = self->priv->possible_in_col;
#line 367 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp115__length1 = self->priv->possible_in_col_length1;
#line 367 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp115__length2 = self->priv->possible_in_col_length2;
#line 367 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp116_ = col;
#line 367 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp117_ = previous_val;
#line 367 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp115_[(_tmp116_ * _tmp115__length2) + _tmp117_] = TRUE;
#line 367 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp118_ = _tmp115_[(_tmp116_ * _tmp115__length2) + _tmp117_];
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp119_ = self->priv->possible_in_block;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp119__length1 = self->priv->possible_in_block_length1;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp119__length2 = self->priv->possible_in_block_length2;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp119__length3 = self->priv->possible_in_block_length3;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp120_ = row;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp121_ = self->priv->_block_cols;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp122_ = col;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp123_ = self->priv->_block_rows;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp124_ = previous_val;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp119_[((((_tmp120_ / _tmp121_) * _tmp119__length2) + (_tmp122_ / _tmp123_)) * _tmp119__length3) + _tmp124_] = TRUE;
#line 368 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp125_ = _tmp119_[((((_tmp120_ / _tmp121_) * _tmp119__length2) + (_tmp122_ / _tmp123_)) * _tmp119__length3) + _tmp124_];
#line 3359 "sudoku-board.c"
	}
#line 371 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp126_ = self->priv->_filled;
#line 371 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	sudoku_board_set_filled (self, _tmp126_ - 1);
#line 3365 "sudoku-board.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return self ? g_object_ref (self) : NULL;
#line 3372 "sudoku-board.c"
}


GeeSet* sudoku_board_get_occurances (SudokuBoard* self, GeeList* coords, gint val) {
	GeeSet* result = NULL;
	GeeSet* occurances = NULL;
	GeeHashSet* _tmp0_ = NULL;
#line 374 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 374 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (coords != NULL, NULL);
#line 376 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = gee_hash_set_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, coord_free, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 376 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	occurances = (GeeSet*) _tmp0_;
#line 3388 "sudoku-board.c"
	{
		GeeList* _coord_list = NULL;
		GeeList* _tmp1_ = NULL;
		GeeList* _tmp2_ = NULL;
		gint _coord_size = 0;
		GeeList* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _coord_index = 0;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp1_ = coords;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_coord_list = _tmp2_;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp3_ = _coord_list;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5_ = _tmp4_;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_coord_size = _tmp5_;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_coord_index = -1;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		while (TRUE) {
#line 3416 "sudoku-board.c"
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			Coord coord = {0};
			GeeList* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			gpointer _tmp11_ = NULL;
			Coord* _tmp12_ = NULL;
			Coord _tmp13_ = {0};
			gint* _tmp14_ = NULL;
			gint _tmp14__length1 = 0;
			gint _tmp14__length2 = 0;
			Coord _tmp15_ = {0};
			gint _tmp16_ = 0;
			Coord _tmp17_ = {0};
			gint _tmp18_ = 0;
			gint _tmp19_ = 0;
			gint _tmp20_ = 0;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp6_ = _coord_index;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_coord_index = _tmp6_ + 1;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp7_ = _coord_index;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp8_ = _coord_size;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				break;
#line 3447 "sudoku-board.c"
			}
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp9_ = _coord_list;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp10_ = _coord_index;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp11_ = gee_list_get (_tmp9_, _tmp10_);
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp12_ = (Coord*) _tmp11_;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp13_ = *_tmp12_;
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_coord_free0 (_tmp12_);
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			coord = _tmp13_;
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp14_ = self->cells;
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp14__length1 = self->cells_length1;
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp14__length2 = self->cells_length2;
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp15_ = coord;
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp16_ = _tmp15_.row;
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp17_ = coord;
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp18_ = _tmp17_.col;
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + _tmp18_];
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp20_ = val;
#line 379 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			if (_tmp19_ == _tmp20_) {
#line 3483 "sudoku-board.c"
				GeeSet* _tmp21_ = NULL;
				Coord _tmp22_ = {0};
#line 380 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp21_ = occurances;
#line 380 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp22_ = coord;
#line 380 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp21_, &_tmp22_);
#line 3492 "sudoku-board.c"
			}
		}
#line 377 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_coord_list);
#line 3497 "sudoku-board.c"
	}
#line 383 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = occurances;
#line 383 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 3503 "sudoku-board.c"
}


gboolean sudoku_board_row_contains (SudokuBoard* self, gint row, gint val) {
	gboolean result = FALSE;
	GeeList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gpointer _tmp2_ = NULL;
	GeeList* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	GeeSet* _tmp5_ = NULL;
	GeeSet* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gboolean _tmp9_ = FALSE;
#line 386 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->coords_for_row;
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = row;
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = gee_list_get (_tmp0_, _tmp1_);
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = (GeeList*) _tmp2_;
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = val;
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5_ = sudoku_board_get_occurances (self, _tmp3_, _tmp4_);
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp6_ = _tmp5_;
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp8_ = _tmp7_;
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9_ = _tmp8_ != 0;
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (_tmp6_);
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (_tmp3_);
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp9_;
#line 388 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 3549 "sudoku-board.c"
}


gboolean sudoku_board_col_contains (SudokuBoard* self, gint col, gint val) {
	gboolean result = FALSE;
	GeeList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gpointer _tmp2_ = NULL;
	GeeList* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	GeeSet* _tmp5_ = NULL;
	GeeSet* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gboolean _tmp9_ = FALSE;
#line 391 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->coords_for_col;
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = col;
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = gee_list_get (_tmp0_, _tmp1_);
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = (GeeList*) _tmp2_;
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = val;
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5_ = sudoku_board_get_occurances (self, _tmp3_, _tmp4_);
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp6_ = _tmp5_;
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp8_ = _tmp7_;
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9_ = _tmp8_ != 0;
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (_tmp6_);
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (_tmp3_);
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp9_;
#line 393 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 3595 "sudoku-board.c"
}


gboolean sudoku_board_block_contains (SudokuBoard* self, Coord* block, gint val) {
	gboolean result = FALSE;
	GeeMap* _tmp0_ = NULL;
	Coord _tmp1_ = {0};
	gpointer _tmp2_ = NULL;
	GeeList* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	GeeSet* _tmp5_ = NULL;
	GeeSet* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gboolean _tmp9_ = FALSE;
#line 396 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 396 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (block != NULL, FALSE);
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->coords_for_block;
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = *block;
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = gee_map_get (_tmp0_, &_tmp1_);
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = (GeeList*) _tmp2_;
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = val;
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5_ = sudoku_board_get_occurances (self, _tmp3_, _tmp4_);
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp6_ = _tmp5_;
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp8_ = _tmp7_;
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp9_ = _tmp8_ != 0;
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (_tmp6_);
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (_tmp3_);
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp9_;
#line 398 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 3643 "sudoku-board.c"
}


static void sudoku_board_remove_breakages_for (SudokuBoard* self, GeeList* coords, gint val) {
#line 401 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 401 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (coords != NULL);
#line 3652 "sudoku-board.c"
	{
		GeeList* _coord_list = NULL;
		GeeList* _tmp0_ = NULL;
		GeeList* _tmp1_ = NULL;
		gint _coord_size = 0;
		GeeList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _coord_index = 0;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp0_ = coords;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_coord_list = _tmp1_;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp2_ = _coord_list;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp4_ = _tmp3_;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_coord_size = _tmp4_;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_coord_index = -1;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		while (TRUE) {
#line 3680 "sudoku-board.c"
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			Coord coord = {0};
			GeeList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			Coord* _tmp11_ = NULL;
			Coord _tmp12_ = {0};
			gboolean _tmp13_ = FALSE;
			gint* _tmp14_ = NULL;
			gint _tmp14__length1 = 0;
			gint _tmp14__length2 = 0;
			Coord _tmp15_ = {0};
			gint _tmp16_ = 0;
			Coord _tmp17_ = {0};
			gint _tmp18_ = 0;
			gint _tmp19_ = 0;
			gint _tmp20_ = 0;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp5_ = _coord_index;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_coord_index = _tmp5_ + 1;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp6_ = _coord_index;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp7_ = _coord_size;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				break;
#line 3712 "sudoku-board.c"
			}
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp8_ = _coord_list;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp9_ = _coord_index;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp10_ = gee_list_get (_tmp8_, _tmp9_);
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp11_ = (Coord*) _tmp10_;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp12_ = *_tmp11_;
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_coord_free0 (_tmp11_);
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			coord = _tmp12_;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp14_ = self->cells;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp14__length1 = self->cells_length1;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp14__length2 = self->cells_length2;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp15_ = coord;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp16_ = _tmp15_.row;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp17_ = coord;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp18_ = _tmp17_.col;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + _tmp18_];
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp20_ = val;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			if (_tmp19_ == _tmp20_) {
#line 3748 "sudoku-board.c"
				GeeSet* _tmp21_ = NULL;
				Coord _tmp22_ = {0};
				gboolean _tmp23_ = FALSE;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp21_ = self->broken_coords;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp22_ = coord;
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp23_ = gee_collection_contains ((GeeCollection*) _tmp21_, &_tmp22_);
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp13_ = _tmp23_;
#line 3760 "sudoku-board.c"
			} else {
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp13_ = FALSE;
#line 3764 "sudoku-board.c"
			}
#line 405 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			if (_tmp13_) {
#line 3768 "sudoku-board.c"
				GeeSet* _tmp24_ = NULL;
				Coord _tmp25_ = {0};
#line 406 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp24_ = self->broken_coords;
#line 406 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp25_ = coord;
#line 406 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				gee_collection_remove ((GeeCollection*) _tmp24_, &_tmp25_);
#line 3777 "sudoku-board.c"
			}
		}
#line 403 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_g_object_unref0 (_coord_list);
#line 3782 "sudoku-board.c"
	}
}


static void sudoku_board_mark_breakages_for (SudokuBoard* self, GeeList* coords, gint val) {
	GeeSet* occurances = NULL;
	GeeList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GeeSet* _tmp2_ = NULL;
	GeeSet* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
#line 412 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 412 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (coords != NULL);
#line 414 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = coords;
#line 414 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = val;
#line 414 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_get_occurances (self, _tmp0_, _tmp1_);
#line 414 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	occurances = _tmp2_;
#line 415 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = occurances;
#line 415 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 415 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5_ = _tmp4_;
#line 415 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp5_ != 1) {
#line 3815 "sudoku-board.c"
		GeeSet* _tmp6_ = NULL;
		GeeSet* _tmp7_ = NULL;
#line 417 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp6_ = self->broken_coords;
#line 417 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp7_ = occurances;
#line 417 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		gee_collection_add_all ((GeeCollection*) _tmp6_, (GeeCollection*) _tmp7_);
#line 3824 "sudoku-board.c"
	}
#line 412 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (occurances);
#line 3828 "sudoku-board.c"
}


void sudoku_board_to_initial_state (SudokuBoard* self) {
#line 421 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 3835 "sudoku-board.c"
	{
		gint l1 = 0;
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		l1 = 0;
#line 3840 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 3847 "sudoku-board.c"
				gint _tmp2_ = 0;
				gint _tmp3_ = 0;
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 3852 "sudoku-board.c"
					gint _tmp1_ = 0;
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp1_ = l1;
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l1 = _tmp1_ + 1;
#line 3858 "sudoku-board.c"
				}
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp2_ = l1;
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp3_ = self->priv->_rows;
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp2_ < _tmp3_)) {
#line 423 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 3870 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l2 = 0;
#line 3876 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 3883 "sudoku-board.c"
							gint _tmp6_ = 0;
							gint _tmp7_ = 0;
							gboolean* _tmp8_ = NULL;
							gint _tmp8__length1 = 0;
							gint _tmp8__length2 = 0;
							gint _tmp9_ = 0;
							gint _tmp10_ = 0;
							gboolean _tmp11_ = FALSE;
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 3894 "sudoku-board.c"
								gint _tmp5_ = 0;
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp5_ = l2;
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								l2 = _tmp5_ + 1;
#line 3900 "sudoku-board.c"
							}
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp6_ = l2;
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp7_ = self->priv->_cols;
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp6_ < _tmp7_)) {
#line 425 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 3912 "sudoku-board.c"
							}
#line 427 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp8_ = self->is_fixed;
#line 427 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp8__length1 = self->is_fixed_length1;
#line 427 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp8__length2 = self->is_fixed_length2;
#line 427 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp9_ = l1;
#line 427 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp10_ = l2;
#line 427 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp11_ = _tmp8_[(_tmp9_ * _tmp8__length2) + _tmp10_];
#line 427 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp11_) {
#line 3928 "sudoku-board.c"
								gint _tmp12_ = 0;
								gint _tmp13_ = 0;
#line 428 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp12_ = l1;
#line 428 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp13_ = l2;
#line 428 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								sudoku_board_remove (self, _tmp12_, _tmp13_, FALSE);
#line 3937 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
}


void sudoku_board_print (SudokuBoard* self, gint indent) {
	FILE* _tmp22_ = NULL;
#line 433 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 3952 "sudoku-board.c"
	{
		gint l1 = 0;
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		l1 = 0;
#line 3957 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 3964 "sudoku-board.c"
				gint _tmp2_ = 0;
				FILE* _tmp21_ = NULL;
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 3969 "sudoku-board.c"
					gint _tmp1_ = 0;
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp1_ = l1;
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l1 = _tmp1_ + 1;
#line 3975 "sudoku-board.c"
				}
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp2_ = l1;
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp2_ < 9)) {
#line 434 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 3985 "sudoku-board.c"
				}
				{
					gint i = 0;
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					i = 0;
#line 3991 "sudoku-board.c"
					{
						gboolean _tmp3_ = FALSE;
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp3_ = TRUE;
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 3998 "sudoku-board.c"
							gint _tmp5_ = 0;
							gint _tmp6_ = 0;
							FILE* _tmp7_ = NULL;
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp3_) {
#line 4004 "sudoku-board.c"
								gint _tmp4_ = 0;
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp4_ = i;
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								i = _tmp4_ + 1;
#line 4010 "sudoku-board.c"
							}
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp3_ = FALSE;
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp5_ = i;
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp6_ = indent;
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp5_ < _tmp6_)) {
#line 436 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 4022 "sudoku-board.c"
							}
#line 438 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp7_ = stdout;
#line 438 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							fprintf (_tmp7_, " ");
#line 4028 "sudoku-board.c"
						}
					}
				}
				{
					gint l2 = 0;
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l2 = 0;
#line 4036 "sudoku-board.c"
					{
						gboolean _tmp8_ = FALSE;
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp8_ = TRUE;
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 4043 "sudoku-board.c"
							gint _tmp10_ = 0;
							gint* _tmp11_ = NULL;
							gint _tmp11__length1 = 0;
							gint _tmp11__length2 = 0;
							gint _tmp12_ = 0;
							gint _tmp13_ = 0;
							gint _tmp14_ = 0;
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp8_) {
#line 4053 "sudoku-board.c"
								gint _tmp9_ = 0;
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp9_ = l2;
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								l2 = _tmp9_ + 1;
#line 4059 "sudoku-board.c"
							}
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp8_ = FALSE;
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp10_ = l2;
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp10_ < 9)) {
#line 440 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 4069 "sudoku-board.c"
							}
#line 442 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp11_ = self->cells;
#line 442 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp11__length1 = self->cells_length1;
#line 442 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp11__length2 = self->cells_length2;
#line 442 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp12_ = l1;
#line 442 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp13_ = l2;
#line 442 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp14_ = _tmp11_[(_tmp12_ * _tmp11__length2) + _tmp13_];
#line 442 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (_tmp14_ != 0) {
#line 4085 "sudoku-board.c"
								FILE* _tmp15_ = NULL;
								gint* _tmp16_ = NULL;
								gint _tmp16__length1 = 0;
								gint _tmp16__length2 = 0;
								gint _tmp17_ = 0;
								gint _tmp18_ = 0;
								gint _tmp19_ = 0;
#line 443 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp15_ = stdout;
#line 443 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp16_ = self->cells;
#line 443 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp16__length1 = self->cells_length1;
#line 443 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp16__length2 = self->cells_length2;
#line 443 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp17_ = l1;
#line 443 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp18_ = l2;
#line 443 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp19_ = _tmp16_[(_tmp17_ * _tmp16__length2) + _tmp18_];
#line 443 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								fprintf (_tmp15_, "%d ", _tmp19_);
#line 4109 "sudoku-board.c"
							} else {
								FILE* _tmp20_ = NULL;
#line 445 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp20_ = stdout;
#line 445 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								fprintf (_tmp20_, "  ");
#line 4116 "sudoku-board.c"
							}
						}
					}
				}
#line 447 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp21_ = stdout;
#line 447 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				fprintf (_tmp21_, "\n");
#line 4125 "sudoku-board.c"
			}
		}
	}
#line 449 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp22_ = stdout;
#line 449 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	fflush (_tmp22_);
#line 4133 "sudoku-board.c"
}


void sudoku_board_get_string (SudokuBoard* self) {
	FILE* _tmp0_ = NULL;
	FILE* _tmp18_ = NULL;
#line 452 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 453 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = stdout;
#line 453 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	fprintf (_tmp0_, "[ ");
#line 4146 "sudoku-board.c"
	{
		gint l1 = 0;
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		l1 = 0;
#line 4151 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 4158 "sudoku-board.c"
				gint _tmp3_ = 0;
				FILE* _tmp4_ = NULL;
				FILE* _tmp15_ = NULL;
				gint _tmp16_ = 0;
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4165 "sudoku-board.c"
					gint _tmp2_ = 0;
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp2_ = l1;
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l1 = _tmp2_ + 1;
#line 4171 "sudoku-board.c"
				}
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp3_ = l1;
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp3_ < 9)) {
#line 454 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 4181 "sudoku-board.c"
				}
#line 456 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp4_ = stdout;
#line 456 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				fprintf (_tmp4_, "[ ");
#line 4187 "sudoku-board.c"
				{
					gint l2 = 0;
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l2 = 0;
#line 4192 "sudoku-board.c"
					{
						gboolean _tmp5_ = FALSE;
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp5_ = TRUE;
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 4199 "sudoku-board.c"
							gint _tmp7_ = 0;
							FILE* _tmp8_ = NULL;
							gint* _tmp9_ = NULL;
							gint _tmp9__length1 = 0;
							gint _tmp9__length2 = 0;
							gint _tmp10_ = 0;
							gint _tmp11_ = 0;
							gint _tmp12_ = 0;
							gint _tmp13_ = 0;
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp5_) {
#line 4211 "sudoku-board.c"
								gint _tmp6_ = 0;
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp6_ = l2;
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								l2 = _tmp6_ + 1;
#line 4217 "sudoku-board.c"
							}
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp5_ = FALSE;
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp7_ = l2;
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp7_ < 9)) {
#line 457 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 4227 "sudoku-board.c"
							}
#line 459 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp8_ = stdout;
#line 459 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp9_ = self->cells;
#line 459 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp9__length1 = self->cells_length1;
#line 459 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp9__length2 = self->cells_length2;
#line 459 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp10_ = l1;
#line 459 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp11_ = l2;
#line 459 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp12_ = _tmp9_[(_tmp10_ * _tmp9__length2) + _tmp11_];
#line 459 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							fprintf (_tmp8_, "%d", _tmp12_);
#line 460 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp13_ = l2;
#line 460 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (_tmp13_ != 8) {
#line 4249 "sudoku-board.c"
								FILE* _tmp14_ = NULL;
#line 461 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp14_ = stdout;
#line 461 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								fprintf (_tmp14_, ",");
#line 4255 "sudoku-board.c"
							}
						}
					}
				}
#line 463 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp15_ = stdout;
#line 463 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				fprintf (_tmp15_, " ]");
#line 464 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp16_ = l1;
#line 464 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (_tmp16_ != 8) {
#line 4268 "sudoku-board.c"
					FILE* _tmp17_ = NULL;
#line 465 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp17_ = stdout;
#line 465 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					fprintf (_tmp17_, ",");
#line 4274 "sudoku-board.c"
				}
			}
		}
	}
#line 467 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp18_ = stdout;
#line 467 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	fprintf (_tmp18_, " ]");
#line 4283 "sudoku-board.c"
}


gchar* sudoku_board_to_string (SudokuBoard* self, gboolean get_original_state) {
	gchar* result = NULL;
	gchar* board_string = NULL;
	gchar* _tmp0_ = NULL;
#line 470 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 472 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = g_strdup ("");
#line 472 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board_string = _tmp0_;
#line 4297 "sudoku-board.c"
	{
		gint i = 0;
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		i = 0;
#line 4302 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 4309 "sudoku-board.c"
				gint _tmp3_ = 0;
				gint _tmp4_ = 0;
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4314 "sudoku-board.c"
					gint _tmp2_ = 0;
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp2_ = i;
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					i = _tmp2_ + 1;
#line 4320 "sudoku-board.c"
				}
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp3_ = i;
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp4_ = self->priv->_rows;
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp3_ < _tmp4_)) {
#line 473 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 4332 "sudoku-board.c"
				}
				{
					gint j = 0;
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					j = 0;
#line 4338 "sudoku-board.c"
					{
						gboolean _tmp5_ = FALSE;
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp5_ = TRUE;
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 4345 "sudoku-board.c"
							gint _tmp7_ = 0;
							gint _tmp8_ = 0;
							gboolean* _tmp9_ = NULL;
							gint _tmp9__length1 = 0;
							gint _tmp9__length2 = 0;
							gint _tmp10_ = 0;
							gint _tmp11_ = 0;
							gboolean _tmp12_ = FALSE;
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp5_) {
#line 4356 "sudoku-board.c"
								gint _tmp6_ = 0;
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp6_ = j;
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								j = _tmp6_ + 1;
#line 4362 "sudoku-board.c"
							}
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp5_ = FALSE;
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp7_ = j;
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp8_ = self->priv->_cols;
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp7_ < _tmp8_)) {
#line 475 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 4374 "sudoku-board.c"
							}
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp9_ = self->is_fixed;
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp9__length1 = self->is_fixed_length1;
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp9__length2 = self->is_fixed_length2;
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp10_ = i;
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp11_ = j;
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp12_ = _tmp9_[(_tmp10_ * _tmp9__length2) + _tmp11_];
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (_tmp12_) {
#line 4390 "sudoku-board.c"
								const gchar* _tmp13_ = NULL;
								gint* _tmp14_ = NULL;
								gint _tmp14__length1 = 0;
								gint _tmp14__length2 = 0;
								gint _tmp15_ = 0;
								gint _tmp16_ = 0;
								gint _tmp17_ = 0;
								gchar* _tmp18_ = NULL;
								gchar* _tmp19_ = NULL;
								gchar* _tmp20_ = NULL;
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp13_ = board_string;
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp14_ = self->cells;
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp14__length1 = self->cells_length1;
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp14__length2 = self->cells_length2;
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp15_ = i;
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp16_ = j;
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp17_ = _tmp14_[(_tmp15_ * _tmp14__length2) + _tmp16_];
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp18_ = g_strdup_printf ("%i", _tmp17_);
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp19_ = _tmp18_;
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp20_ = g_strconcat (_tmp13_, _tmp19_, NULL);
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_g_free0 (board_string);
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								board_string = _tmp20_;
#line 478 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_g_free0 (_tmp19_);
#line 4427 "sudoku-board.c"
							} else {
								gchar* _tmp21_ = NULL;
								gboolean _tmp22_ = FALSE;
								const gchar* _tmp29_ = NULL;
								gchar* _tmp30_ = NULL;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp22_ = get_original_state;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								if (_tmp22_) {
#line 4437 "sudoku-board.c"
									gchar* _tmp23_ = NULL;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp23_ = g_strdup ("0");
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_g_free0 (_tmp21_);
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp21_ = _tmp23_;
#line 4445 "sudoku-board.c"
								} else {
									gint* _tmp24_ = NULL;
									gint _tmp24__length1 = 0;
									gint _tmp24__length2 = 0;
									gint _tmp25_ = 0;
									gint _tmp26_ = 0;
									gint _tmp27_ = 0;
									gchar* _tmp28_ = NULL;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp24_ = self->cells;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp24__length1 = self->cells_length1;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp24__length2 = self->cells_length2;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp25_ = i;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp26_ = j;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp27_ = _tmp24_[(_tmp25_ * _tmp24__length2) + _tmp26_];
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp28_ = g_strdup_printf ("%i", _tmp27_);
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_g_free0 (_tmp21_);
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									_tmp21_ = _tmp28_;
#line 4472 "sudoku-board.c"
								}
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp29_ = board_string;
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp30_ = g_strconcat (_tmp29_, _tmp21_, NULL);
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_g_free0 (board_string);
#line 480 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								board_string = _tmp30_;
#line 477 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_g_free0 (_tmp21_);
#line 4484 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 483 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = board_string;
#line 483 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 4496 "sudoku-board.c"
}


static gint* _vala_array_dup8 (gint* self, int length) {
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gint));
#line 4503 "sudoku-board.c"
}


gint* sudoku_board_get_cells (SudokuBoard* self, int* result_length1, int* result_length2) {
	gint* result = NULL;
	gint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gint _tmp1__length2 = 0;
	gint* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gint _tmp2__length2 = 0;
#line 486 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup8 (_tmp0_, _tmp0__length1 * _tmp0__length2) : ((gpointer) _tmp0_);
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1__length1 = _tmp0__length1;
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1__length2 = _tmp0__length2;
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2__length1 = _tmp1__length1;
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2__length2 = _tmp1__length2;
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (result_length1) {
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		*result_length1 = _tmp2__length1;
#line 4542 "sudoku-board.c"
	}
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (result_length2) {
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		*result_length2 = _tmp2__length2;
#line 4548 "sudoku-board.c"
	}
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp2_;
#line 488 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 4554 "sudoku-board.c"
}


GeeHashMap* sudoku_board_calculate_open_squares (SudokuBoard* self) {
	GeeHashMap* result = NULL;
	GeeHashMap* possibilities = NULL;
	GeeHashMap* _tmp0_ = NULL;
#line 491 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 492 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = gee_hash_map_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, coord_free, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL, NULL, NULL, NULL);
#line 492 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	possibilities = _tmp0_;
#line 4568 "sudoku-board.c"
	{
		gint l1 = 0;
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		l1 = 0;
#line 4573 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 4580 "sudoku-board.c"
				gint _tmp3_ = 0;
				gint _tmp4_ = 0;
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4585 "sudoku-board.c"
					gint _tmp2_ = 0;
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp2_ = l1;
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l1 = _tmp2_ + 1;
#line 4591 "sudoku-board.c"
				}
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp3_ = l1;
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp4_ = self->priv->_rows;
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp3_ < _tmp4_)) {
#line 493 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 4603 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					l2 = 0;
#line 4609 "sudoku-board.c"
					{
						gboolean _tmp5_ = FALSE;
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						_tmp5_ = TRUE;
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
						while (TRUE) {
#line 4616 "sudoku-board.c"
							gint _tmp7_ = 0;
							gint _tmp8_ = 0;
							gint* _tmp9_ = NULL;
							gint _tmp9__length1 = 0;
							gint _tmp9__length2 = 0;
							gint _tmp10_ = 0;
							gint _tmp11_ = 0;
							gint _tmp12_ = 0;
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!_tmp5_) {
#line 4627 "sudoku-board.c"
								gint _tmp6_ = 0;
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp6_ = l2;
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								l2 = _tmp6_ + 1;
#line 4633 "sudoku-board.c"
							}
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp5_ = FALSE;
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp7_ = l2;
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp8_ = self->priv->_cols;
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (!(_tmp7_ < _tmp8_)) {
#line 495 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								break;
#line 4645 "sudoku-board.c"
							}
#line 497 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp9_ = self->cells;
#line 497 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp9__length1 = self->cells_length1;
#line 497 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp9__length2 = self->cells_length2;
#line 497 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp10_ = l1;
#line 497 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp11_ = l2;
#line 497 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							_tmp12_ = _tmp9_[(_tmp10_ * _tmp9__length2) + _tmp11_];
#line 497 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
							if (_tmp12_ == 0) {
#line 4661 "sudoku-board.c"
								GeeArrayList* possArrayList = NULL;
								GeeArrayList* _tmp13_ = NULL;
								gint* possArray = NULL;
								gint _tmp14_ = 0;
								gint _tmp15_ = 0;
								gint _tmp16_ = 0;
								gint* _tmp17_ = NULL;
								gint possArray_length1 = 0;
								gint _possArray_size_ = 0;
								gint* _tmp18_ = NULL;
								gint _tmp18__length1 = 0;
								GeeHashMap* _tmp21_ = NULL;
								gint _tmp22_ = 0;
								gint _tmp23_ = 0;
								Coord _tmp24_ = {0};
								GeeArrayList* _tmp25_ = NULL;
#line 499 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp13_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 499 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								possArrayList = _tmp13_;
#line 500 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp14_ = l1;
#line 500 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp15_ = l2;
#line 500 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp17_ = sudoku_board_get_possibilities (self, _tmp14_, _tmp15_, &_tmp16_);
#line 500 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								possArray = _tmp17_;
#line 500 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								possArray_length1 = _tmp16_;
#line 500 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_possArray_size_ = possArray_length1;
#line 501 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp18_ = possArray;
#line 501 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp18__length1 = possArray_length1;
#line 4698 "sudoku-board.c"
								{
									gint* i_collection = NULL;
									gint i_collection_length1 = 0;
									gint _i_collection_size_ = 0;
									gint i_it = 0;
#line 501 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									i_collection = _tmp18_;
#line 501 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									i_collection_length1 = _tmp18__length1;
#line 501 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
									for (i_it = 0; i_it < _tmp18__length1; i_it = i_it + 1) {
#line 4710 "sudoku-board.c"
										gint i = 0;
#line 501 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
										i = i_collection[i_it];
#line 4714 "sudoku-board.c"
										{
											GeeArrayList* _tmp19_ = NULL;
											gint _tmp20_ = 0;
#line 502 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
											_tmp19_ = possArrayList;
#line 502 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
											_tmp20_ = i;
#line 502 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
											gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, (gpointer) ((gintptr) _tmp20_));
#line 4724 "sudoku-board.c"
										}
									}
								}
#line 504 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp21_ = possibilities;
#line 504 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp22_ = l1;
#line 504 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp23_ = l2;
#line 504 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								coord_init (&_tmp24_, _tmp22_, _tmp23_);
#line 504 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_tmp25_ = possArrayList;
#line 504 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, &_tmp24_, _tmp25_);
#line 497 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								possArray = (g_free (possArray), NULL);
#line 497 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
								_g_object_unref0 (possArrayList);
#line 4744 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 508 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = possibilities;
#line 508 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 4756 "sudoku-board.c"
}


gboolean sudoku_board_is_finished (SudokuBoard* self) {
	gboolean result = FALSE;
	gchar* board_string = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* finishgame_file = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GFile* file = NULL;
	GFile* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
#line 511 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 513 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_to_string (self, TRUE);
#line 513 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 513 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = g_strconcat (_tmp1_, ".save", NULL);
#line 513 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = _tmp2_;
#line 513 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_free0 (_tmp1_);
#line 513 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	board_string = _tmp3_;
#line 514 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = sudoku_saver_get_finishgame_dir ();
#line 514 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5_ = _tmp4_;
#line 514 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp6_ = g_build_path (G_DIR_SEPARATOR_S, _tmp5_, board_string, NULL);
#line 514 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	finishgame_file = _tmp6_;
#line 515 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp7_ = g_file_new_for_path (finishgame_file);
#line 515 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	file = _tmp7_;
#line 517 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp8_ = g_file_query_exists (file, NULL);
#line 517 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp8_;
#line 517 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (file);
#line 517 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_free0 (finishgame_file);
#line 517 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_free0 (board_string);
#line 517 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 4812 "sudoku-board.c"
}


gchar* sudoku_board_get_earmarks_string (SudokuBoard* self, gint row, gint col) {
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_ = NULL;
#line 520 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 522 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = g_strdup ("");
#line 522 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	s = _tmp0_;
#line 4826 "sudoku-board.c"
	{
		gint i = 0;
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		i = 1;
#line 4831 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			while (TRUE) {
#line 4838 "sudoku-board.c"
				gint _tmp3_ = 0;
				gint _tmp4_ = 0;
				gint _tmp5_ = 0;
				gboolean* _tmp6_ = NULL;
				gint _tmp6__length1 = 0;
				gint _tmp6__length2 = 0;
				gint _tmp6__length3 = 0;
				gint _tmp7_ = 0;
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gboolean _tmp10_ = FALSE;
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4852 "sudoku-board.c"
					gint _tmp2_ = 0;
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp2_ = i;
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					i = _tmp2_ + 1;
#line 4858 "sudoku-board.c"
				}
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp3_ = i;
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp4_ = sudoku_board_get_max_val (self);
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp5_ = _tmp4_;
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (!(_tmp3_ <= _tmp5_)) {
#line 523 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					break;
#line 4872 "sudoku-board.c"
				}
#line 524 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp6_ = self->priv->earmarks;
#line 524 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp6__length1 = self->priv->earmarks_length1;
#line 524 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp6__length2 = self->priv->earmarks_length2;
#line 524 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp6__length3 = self->priv->earmarks_length3;
#line 524 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp7_ = row;
#line 524 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp8_ = col;
#line 524 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp9_ = i;
#line 524 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				_tmp10_ = _tmp6_[(((_tmp7_ * _tmp6__length2) + _tmp8_) * _tmp6__length3) + (_tmp9_ - 1)];
#line 524 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				if (_tmp10_) {
#line 4892 "sudoku-board.c"
					const gchar* _tmp11_ = NULL;
					gint _tmp12_ = 0;
					gchar* _tmp13_ = NULL;
					gchar* _tmp14_ = NULL;
					gchar* _tmp15_ = NULL;
#line 525 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp11_ = s;
#line 525 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp12_ = i;
#line 525 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp13_ = g_strdup_printf ("%i", _tmp12_);
#line 525 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp14_ = _tmp13_;
#line 525 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 525 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_g_free0 (s);
#line 525 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					s = _tmp15_;
#line 525 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
					_g_free0 (_tmp14_);
#line 4914 "sudoku-board.c"
				}
			}
		}
	}
#line 527 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = s;
#line 527 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 4923 "sudoku-board.c"
}


gdouble sudoku_board_get_previous_played_time (SudokuBoard* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->_previous_played_time;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 4938 "sudoku-board.c"
}


void sudoku_board_set_previous_played_time (SudokuBoard* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = value;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->_previous_played_time = _tmp0_;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_notify ((GObject *) self, "previous-played-time");
#line 4952 "sudoku-board.c"
}


DifficultyCategory sudoku_board_get_difficulty_category (SudokuBoard* self) {
	DifficultyCategory result;
	DifficultyCategory _tmp0_ = 0;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->_difficulty_category;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 4967 "sudoku-board.c"
}


void sudoku_board_set_difficulty_category (SudokuBoard* self, DifficultyCategory value) {
	DifficultyCategory _tmp0_ = 0;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = value;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->_difficulty_category = _tmp0_;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_notify ((GObject *) self, "difficulty-category");
#line 4981 "sudoku-board.c"
}


gint sudoku_board_get_block_rows (SudokuBoard* self) {
	gint result;
	gint _tmp0_ = 0;
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 4996 "sudoku-board.c"
}


static void sudoku_board_set_block_rows (SudokuBoard* self, gint value) {
	gint _tmp0_ = 0;
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = value;
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->_block_rows = _tmp0_;
#line 42 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_notify ((GObject *) self, "block-rows");
#line 5010 "sudoku-board.c"
}


gint sudoku_board_get_block_cols (SudokuBoard* self) {
	gint result;
	gint _tmp0_ = 0;
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_cols;
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5025 "sudoku-board.c"
}


static void sudoku_board_set_block_cols (SudokuBoard* self, gint value) {
	gint _tmp0_ = 0;
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = value;
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->_block_cols = _tmp0_;
#line 45 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_notify ((GObject *) self, "block-cols");
#line 5039 "sudoku-board.c"
}


gint sudoku_board_get_rows (SudokuBoard* self) {
	gint result;
	gint _tmp0_ = 0;
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5054 "sudoku-board.c"
}


static void sudoku_board_set_rows (SudokuBoard* self, gint value) {
	gint _tmp0_ = 0;
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = value;
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->_rows = _tmp0_;
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_notify ((GObject *) self, "rows");
#line 5068 "sudoku-board.c"
}


gint sudoku_board_get_cols (SudokuBoard* self) {
	gint result;
	gint _tmp0_ = 0;
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->_cols;
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5083 "sudoku-board.c"
}


static void sudoku_board_set_cols (SudokuBoard* self, gint value) {
	gint _tmp0_ = 0;
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = value;
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->_cols = _tmp0_;
#line 51 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_notify ((GObject *) self, "cols");
#line 5097 "sudoku-board.c"
}


gint sudoku_board_get_max_val (SudokuBoard* self) {
	gint result;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_ * _tmp1_;
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5115 "sudoku-board.c"
}


gboolean sudoku_board_get_broken (SudokuBoard* self) {
	gboolean result;
	GeeSet* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 61 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->broken_coords;
#line 61 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 61 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 61 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp2_ != 0;
#line 61 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5136 "sudoku-board.c"
}


gint sudoku_board_get_filled (SudokuBoard* self) {
	gint result;
	gint _tmp0_ = 0;
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->_filled;
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5151 "sudoku-board.c"
}


static void sudoku_board_set_filled (SudokuBoard* self, gint value) {
	gint _tmp0_ = 0;
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = value;
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->_filled = _tmp0_;
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_notify ((GObject *) self, "filled");
#line 5165 "sudoku-board.c"
}


gint sudoku_board_get_fixed (SudokuBoard* self) {
	gint result;
	gint _tmp0_ = 0;
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = self->priv->_fixed;
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5180 "sudoku-board.c"
}


static void sudoku_board_set_fixed (SudokuBoard* self, gint value) {
	gint _tmp0_ = 0;
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = value;
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->_fixed = _tmp0_;
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_notify ((GObject *) self, "fixed");
#line 5194 "sudoku-board.c"
}


gboolean sudoku_board_get_complete (SudokuBoard* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = self->priv->_filled;
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = self->priv->_cols;
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = self->priv->_rows;
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp1_ == (_tmp2_ * _tmp3_)) {
#line 5214 "sudoku-board.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp4_ = sudoku_board_get_broken (self);
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5_ = _tmp4_;
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp0_ = !_tmp5_;
#line 5223 "sudoku-board.c"
	} else {
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 5227 "sudoku-board.c"
	}
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 72 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5233 "sudoku-board.c"
}


static void sudoku_board_class_init (SudokuBoardClass * klass) {
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	sudoku_board_parent_class = g_type_class_peek_parent (klass);
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_type_class_add_private (klass, sizeof (SudokuBoardPrivate));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_board_get_property;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_board_set_property;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_board_finalize;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_PREVIOUS_PLAYED_TIME, g_param_spec_double ("previous-played-time", "previous-played-time", "previous-played-time", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_DIFFICULTY_CATEGORY, g_param_spec_enum ("difficulty-category", "difficulty-category", "difficulty-category", TYPE_DIFFICULTY_CATEGORY, DIFFICULTY_CATEGORY_UNKNOWN, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BLOCK_ROWS, g_param_spec_int ("block-rows", "block-rows", "block-rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BLOCK_COLS, g_param_spec_int ("block-cols", "block-cols", "block-cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_ROWS, g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COLS, g_param_spec_int ("cols", "cols", "cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_MAX_VAL, g_param_spec_int ("max-val", "max-val", "max-val", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BROKEN, g_param_spec_boolean ("broken", "broken", "broken", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_FILLED, g_param_spec_int ("filled", "filled", "filled", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_FIXED, g_param_spec_int ("fixed", "fixed", "fixed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COMPLETE, g_param_spec_boolean ("complete", "complete", "complete", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_signal_new ("completed", TYPE_SUDOKU_BOARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5272 "sudoku-board.c"
}


static void sudoku_board_instance_init (SudokuBoard * self) {
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv = SUDOKU_BOARD_GET_PRIVATE (self);
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->_previous_played_time = (gdouble) 0;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->_difficulty_category = DIFFICULTY_CATEGORY_UNKNOWN;
#line 5283 "sudoku-board.c"
}


static void sudoku_board_finalize (GObject* obj) {
	SudokuBoard * self;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 28 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->cells = (g_free (self->cells), NULL);
#line 29 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->is_fixed = (g_free (self->is_fixed), NULL);
#line 30 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_row = (g_free (self->priv->possible_in_row), NULL);
#line 31 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_col = (g_free (self->priv->possible_in_col), NULL);
#line 32 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->possible_in_block = (g_free (self->priv->possible_in_block), NULL);
#line 34 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	self->priv->earmarks = (g_free (self->priv->earmarks), NULL);
#line 83 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->broken_coords);
#line 86 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_col);
#line 89 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_row);
#line 92 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_block);
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	G_OBJECT_CLASS (sudoku_board_parent_class)->finalize (obj);
#line 5313 "sudoku-board.c"
}


GType sudoku_board_get_type (void) {
	static volatile gsize sudoku_board_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_board_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SudokuBoardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_board_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuBoard), 0, (GInstanceInitFunc) sudoku_board_instance_init, NULL };
		GType sudoku_board_type_id;
		sudoku_board_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuBoard", &g_define_type_info, 0);
		g_once_init_leave (&sudoku_board_type_id__volatile, sudoku_board_type_id);
	}
	return sudoku_board_type_id__volatile;
}


static void _vala_sudoku_board_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SudokuBoard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	switch (property_id) {
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_PREVIOUS_PLAYED_TIME:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_double (value, sudoku_board_get_previous_played_time (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_DIFFICULTY_CATEGORY:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_enum (value, sudoku_board_get_difficulty_category (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_ROWS:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_block_rows (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_COLS:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_block_cols (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_ROWS:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_rows (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_COLS:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_cols (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_MAX_VAL:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_max_val (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_BROKEN:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_boolean (value, sudoku_board_get_broken (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_FILLED:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_filled (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_FIXED:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_fixed (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_COMPLETE:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		g_value_set_boolean (value, sudoku_board_get_complete (self));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 5400 "sudoku-board.c"
		default:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 5406 "sudoku-board.c"
	}
}


static void _vala_sudoku_board_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SudokuBoard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	switch (property_id) {
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_PREVIOUS_PLAYED_TIME:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_set_previous_played_time (self, g_value_get_double (value));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_DIFFICULTY_CATEGORY:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_set_difficulty_category (self, g_value_get_enum (value));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_ROWS:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_set_block_rows (self, g_value_get_int (value));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_COLS:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_set_block_cols (self, g_value_get_int (value));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_ROWS:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_set_rows (self, g_value_get_int (value));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_COLS:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_set_cols (self, g_value_get_int (value));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_FILLED:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_set_filled (self, g_value_get_int (value));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case SUDOKU_BOARD_FIXED:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, g_value_get_int (value));
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 5464 "sudoku-board.c"
		default:
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		break;
#line 5470 "sudoku-board.c"
	}
}


GType house_get_type (void) {
	static volatile gsize house_type_id__volatile = 0;
	if (g_once_init_enter (&house_type_id__volatile)) {
		static const GEnumValue values[] = {{HOUSE_ROW, "HOUSE_ROW", "row"}, {HOUSE_COLUMN, "HOUSE_COLUMN", "column"}, {HOUSE_BLOCK, "HOUSE_BLOCK", "block"}, {0, NULL, NULL}};
		GType house_type_id;
		house_type_id = g_enum_register_static ("House", values);
		g_once_init_leave (&house_type_id__volatile, house_type_id);
	}
	return house_type_id__volatile;
}


void coord_init (Coord *self, gint row, gint col) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 542 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	memset (self, 0, sizeof (Coord));
#line 544 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = row;
#line 544 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	(*self).row = _tmp0_;
#line 545 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = col;
#line 545 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	(*self).col = _tmp1_;
#line 5500 "sudoku-board.c"
}


gint coord_hash (Coord* coord) {
	gint result = 0;
	Coord _tmp0_ = {0};
	gint _tmp1_ = 0;
	Coord _tmp2_ = {0};
	gint _tmp3_ = 0;
#line 548 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (coord != NULL, 0);
#line 549 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = *coord;
#line 549 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = _tmp0_.row;
#line 549 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = *coord;
#line 549 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = _tmp2_.col;
#line 549 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = (_tmp1_ * 33) ^ _tmp3_;
#line 549 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5524 "sudoku-board.c"
}


gboolean coord_equal (Coord* a, Coord* b) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Coord _tmp1_ = {0};
	gint _tmp2_ = 0;
	Coord _tmp3_ = {0};
	gint _tmp4_ = 0;
#line 552 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 552 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = *a;
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = _tmp1_.row;
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = *b;
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = _tmp3_.row;
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp2_ == _tmp4_) {
#line 5549 "sudoku-board.c"
		Coord _tmp5_ = {0};
		gint _tmp6_ = 0;
		Coord _tmp7_ = {0};
		gint _tmp8_ = 0;
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp5_ = *a;
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp6_ = _tmp5_.col;
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp7_ = *b;
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp8_ = _tmp7_.col;
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp0_ = _tmp6_ == _tmp8_;
#line 5564 "sudoku-board.c"
	} else {
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 5568 "sudoku-board.c"
	}
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 553 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5574 "sudoku-board.c"
}


Coord* coord_dup (const Coord* self) {
	Coord* dup;
#line 537 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	dup = g_new0 (Coord, 1);
#line 537 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	memcpy (dup, self, sizeof (Coord));
#line 537 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return dup;
#line 5586 "sudoku-board.c"
}


void coord_free (Coord* self) {
#line 537 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_free (self);
#line 5593 "sudoku-board.c"
}


GType coord_get_type (void) {
	static volatile gsize coord_type_id__volatile = 0;
	if (g_once_init_enter (&coord_type_id__volatile)) {
		GType coord_type_id;
		coord_type_id = g_boxed_type_register_static ("Coord", (GBoxedCopyFunc) coord_dup, (GBoxedFreeFunc) coord_free);
		g_once_init_leave (&coord_type_id__volatile, coord_type_id);
	}
	return coord_type_id__volatile;
}


void cell_init (Cell *self, Coord* coord, gint val) {
	Coord _tmp0_ = {0};
	gint _tmp1_ = 0;
#line 562 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_if_fail (coord != NULL);
#line 562 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	memset (self, 0, sizeof (Cell));
#line 564 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = *coord;
#line 564 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	(*self).coord = _tmp0_;
#line 565 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = val;
#line 565 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	(*self).val = _tmp1_;
#line 5623 "sudoku-board.c"
}


gint cell_hash (Cell* cell) {
	gint result = 0;
	Cell _tmp0_ = {0};
	Coord _tmp1_ = {0};
	gint _tmp2_ = 0;
	Cell _tmp3_ = {0};
	gint _tmp4_ = 0;
#line 568 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (cell != NULL, 0);
#line 569 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = *cell;
#line 569 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = _tmp0_.coord;
#line 569 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = coord_hash (&_tmp1_);
#line 569 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = *cell;
#line 569 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = _tmp3_.val;
#line 569 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = (_tmp2_ * 33) ^ _tmp4_;
#line 569 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5650 "sudoku-board.c"
}


gboolean cell_equal (Cell* a, Cell* b) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Cell _tmp1_ = {0};
	Coord _tmp2_ = {0};
	Cell _tmp3_ = {0};
	Coord _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
#line 572 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 572 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = *a;
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp2_ = _tmp1_.coord;
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = *b;
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp4_ = _tmp3_.coord;
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp5_ = coord_equal (&_tmp2_, &_tmp4_);
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp5_) {
#line 5678 "sudoku-board.c"
		Cell _tmp6_ = {0};
		gint _tmp7_ = 0;
		Cell _tmp8_ = {0};
		gint _tmp9_ = 0;
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp6_ = *a;
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp7_ = _tmp6_.val;
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp8_ = *b;
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp9_ = _tmp8_.val;
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp0_ = _tmp7_ == _tmp9_;
#line 5693 "sudoku-board.c"
	} else {
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 5697 "sudoku-board.c"
	}
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	result = _tmp0_;
#line 573 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return result;
#line 5703 "sudoku-board.c"
}


Cell* cell_dup (const Cell* self) {
	Cell* dup;
#line 557 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	dup = g_new0 (Cell, 1);
#line 557 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	memcpy (dup, self, sizeof (Cell));
#line 557 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	return dup;
#line 5715 "sudoku-board.c"
}


void cell_free (Cell* self) {
#line 557 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_free (self);
#line 5722 "sudoku-board.c"
}


GType cell_get_type (void) {
	static volatile gsize cell_type_id__volatile = 0;
	if (g_once_init_enter (&cell_type_id__volatile)) {
		GType cell_type_id;
		cell_type_id = g_boxed_type_register_static ("Cell", (GBoxedCopyFunc) cell_dup, (GBoxedFreeFunc) cell_free);
		g_once_init_leave (&cell_type_id__volatile, cell_type_id);
	}
	return cell_type_id__volatile;
}


gchar* difficulty_category_to_string (DifficultyCategory self) {
	gchar* result = NULL;
#line 586 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	switch (self) {
#line 586 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_UNKNOWN:
#line 5743 "sudoku-board.c"
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
#line 589 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp0_ = _ ("Unknown Difficulty");
#line 589 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp1_ = g_strdup (_tmp0_);
#line 589 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			result = _tmp1_;
#line 589 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			return result;
#line 5755 "sudoku-board.c"
		}
#line 586 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 5759 "sudoku-board.c"
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
#line 591 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp2_ = _ ("Easy Difficulty");
#line 591 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 591 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			result = _tmp3_;
#line 591 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			return result;
#line 5771 "sudoku-board.c"
		}
#line 586 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 5775 "sudoku-board.c"
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
#line 593 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp4_ = _ ("Medium Difficulty");
#line 593 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp5_ = g_strdup (_tmp4_);
#line 593 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			result = _tmp5_;
#line 593 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			return result;
#line 5787 "sudoku-board.c"
		}
#line 586 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 5791 "sudoku-board.c"
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
#line 595 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp6_ = _ ("Hard Difficulty");
#line 595 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 595 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			result = _tmp7_;
#line 595 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			return result;
#line 5803 "sudoku-board.c"
		}
#line 586 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 5807 "sudoku-board.c"
		{
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
#line 597 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp8_ = _ ("Very Hard Difficulty");
#line 597 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 597 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			result = _tmp9_;
#line 597 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			return result;
#line 5819 "sudoku-board.c"
		}
		default:
		{
#line 599 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 5825 "sudoku-board.c"
		}
	}
}


gchar* difficulty_category_to_untranslated_string (DifficultyCategory self) {
	gchar* result = NULL;
#line 605 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	switch (self) {
#line 605 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_UNKNOWN:
#line 5837 "sudoku-board.c"
		{
			gchar* _tmp0_ = NULL;
#line 608 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp0_ = g_strdup ("Unknown Difficulty");
#line 608 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			result = _tmp0_;
#line 608 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			return result;
#line 5846 "sudoku-board.c"
		}
#line 605 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 5850 "sudoku-board.c"
		{
			gchar* _tmp1_ = NULL;
#line 610 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp1_ = g_strdup ("Easy Difficulty");
#line 610 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			result = _tmp1_;
#line 610 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			return result;
#line 5859 "sudoku-board.c"
		}
#line 605 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 5863 "sudoku-board.c"
		{
			gchar* _tmp2_ = NULL;
#line 612 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp2_ = g_strdup ("Medium Difficulty");
#line 612 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			result = _tmp2_;
#line 612 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			return result;
#line 5872 "sudoku-board.c"
		}
#line 605 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 5876 "sudoku-board.c"
		{
			gchar* _tmp3_ = NULL;
#line 614 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp3_ = g_strdup ("Hard Difficulty");
#line 614 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			result = _tmp3_;
#line 614 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			return result;
#line 5885 "sudoku-board.c"
		}
#line 605 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 5889 "sudoku-board.c"
		{
			gchar* _tmp4_ = NULL;
#line 616 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			_tmp4_ = g_strdup ("Very Hard Difficulty");
#line 616 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			result = _tmp4_;
#line 616 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			return result;
#line 5898 "sudoku-board.c"
		}
		default:
		{
#line 618 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 5904 "sudoku-board.c"
		}
	}
}


DifficultyCategory difficulty_category_from_string (const gchar* input) {
	DifficultyCategory result = 0;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GQuark _tmp3_ = 0U;
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	static GQuark _tmp2_label0 = 0;
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	static GQuark _tmp2_label1 = 0;
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	static GQuark _tmp2_label2 = 0;
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	static GQuark _tmp2_label3 = 0;
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	static GQuark _tmp2_label4 = 0;
#line 622 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	g_return_val_if_fail (input != NULL, 0);
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp0_ = input;
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("Unknown Difficulty")))) {
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		switch (0) {
#line 5937 "sudoku-board.c"
			default:
			{
#line 627 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_UNKNOWN;
#line 627 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				return result;
#line 5944 "sudoku-board.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("Easy Difficulty")))) {
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		switch (0) {
#line 5950 "sudoku-board.c"
			default:
			{
#line 629 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_EASY;
#line 629 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				return result;
#line 5957 "sudoku-board.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("Medium Difficulty")))) {
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		switch (0) {
#line 5963 "sudoku-board.c"
			default:
			{
#line 631 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_MEDIUM;
#line 631 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				return result;
#line 5970 "sudoku-board.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("Hard Difficulty")))) {
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		switch (0) {
#line 5976 "sudoku-board.c"
			default:
			{
#line 633 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_HARD;
#line 633 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				return result;
#line 5983 "sudoku-board.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("Very Hard Difficulty")))) {
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		switch (0) {
#line 5989 "sudoku-board.c"
			default:
			{
#line 635 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_VERY_HARD;
#line 635 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				return result;
#line 5996 "sudoku-board.c"
			}
		}
	} else {
#line 624 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
		switch (0) {
#line 6002 "sudoku-board.c"
			default:
			{
#line 637 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				g_warning ("sudoku-board.vala:637: Could not parse difficulty level. Falling back " \
"to Easy difficulty");
#line 638 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_EASY;
#line 638 "/home/mcatanzaro/jhbuild/checkout/gnome-sudoku/lib/sudoku-board.vala"
				return result;
#line 6011 "sudoku-board.c"
			}
		}
	}
}


GType difficulty_category_get_type (void) {
	static volatile gsize difficulty_category_type_id__volatile = 0;
	if (g_once_init_enter (&difficulty_category_type_id__volatile)) {
		static const GEnumValue values[] = {{DIFFICULTY_CATEGORY_UNKNOWN, "DIFFICULTY_CATEGORY_UNKNOWN", "unknown"}, {DIFFICULTY_CATEGORY_EASY, "DIFFICULTY_CATEGORY_EASY", "easy"}, {DIFFICULTY_CATEGORY_MEDIUM, "DIFFICULTY_CATEGORY_MEDIUM", "medium"}, {DIFFICULTY_CATEGORY_HARD, "DIFFICULTY_CATEGORY_HARD", "hard"}, {DIFFICULTY_CATEGORY_VERY_HARD, "DIFFICULTY_CATEGORY_VERY_HARD", "very-hard"}, {0, NULL, NULL}};
		GType difficulty_category_type_id;
		difficulty_category_type_id = g_enum_register_static ("DifficultyCategory", values);
		g_once_init_leave (&difficulty_category_type_id__volatile, difficulty_category_type_id);
	}
	return difficulty_category_type_id__volatile;
}



